;313ci
;37B7x
;aa4ew
;336Ai
;337Fi
;30D8x          ;96B6 tégla vissza 5047w 9e35x
        org     19efh
        db      0eh,0ah,00h,0ddh
        db      "USR"
        db      96h
        db      "6656"
        db      95h,0ffh,00h,00h,00h
;STACK           equ     4000h
STACK           equ     0700h
VRAM            equ     8000h
SCREEN          equ     VRAM + 3*512+64


allmaps         equ     1
test            equ     0
invulnerable    equ     0               ;92e0 3xnop 986B 9E82 9E1F
    if  allmaps = 0
MAX_LEVEL       equ     49
    else
MAX_LEVEL       equ     75
    endif
brkanimend      equ     0feh
clRed           equ     44h
clGreen         equ     50h
clCyan          equ     51h
clYellow        equ     54h
clPurple        equ     45h
clWhite         equ     55h

;15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
; 0  1  0 Y7 Y6 Y2 Y1 Y0 Y5 Y4 Y3 X4 X3 X2 X1 X0

;                defs    STACK-$

BORDER          equ     00h
PAGES           equ     02h
PITCHL          equ     04h
PITCHH          equ     05h
VOLUME          equ     06h
SPEAKER         equ     06h
CLRINT          equ     07h
Palette0        equ     60h
Palette1        equ     61h
Palette2        equ     62h
Palette3        equ     63h
CRTADDR         equ     70h
CRTDATA         equ     71h

;elements
E.EMPTY         equ     00h
E.WALL          equ     01h
E.CONCRETE      equ     02h
E.LADDER        equ     03h
E.CLIMB         equ     04h             ;climbing frame
E.HWALL         equ     05h             ;hidden wall (enemy in wall(
E.HIDDEN        equ     06h             ;hidden ladder
E.CHEST         equ     07h

start:          jp      gameStart

irqRows:        dw      128*3-1,128*4-1,128*5-1,128*6-1,128*7-1,128*8-1,128*9-1,128*10-1
                dw      128*11-1,128*12-1,128*13-1,128*14-1,128*15-1,128*16-1,128*17-1,128*18-1
                dw      128*19-1,128*20-1,128*21-1,128*22-1,128*23-1,128*24-1,128*25-1,128*26-1
                dw      128*27-1

irqPalette:     db      0, 0,0,0
Palette:        ds      24*4

irqPhase:       dw      0
retrace:        db      0

irq:            push    af                      ;hasznalt regiszterek
                push    bc
                push    hl
                ld      hl,irqRows              ;cursor cim tablazat
                ld      bc,(irqPhase)           ;melyik fazis jon?
                add     hl,bc                   ;(HL<-kovetkezo cursor cim)

                ld      a,15                    ;kovetkezo megszakitas cim a 6845-be
                out     (CRTADDR),a             ;CURSOR LOW address
                ld      a,(hl)
                out     (CRTDATA),a             ;cursor cim also
                inc     hl
                ld      a,14
                out     (CRTADDR),a             ;CURSOR HIGH address
                ld      a,(hl)
                out     (CRTDATA),a             ;cursor cim felso

                ld      hl,irqPalette+1         ;Palette0 mindig fekete
                add     hl,bc
                add     hl,bc                   ;Palette offset
                ld      a,c                     ;fazis elokeszitese a kovetkezo szamolasahoz
                ld      c,Palette1              ;Palette1 regiszter
                outi                            ;<-(HL++)
                inc     c                       ;Palette2
                outi                            ;<-(HL++)
                inc     c                       ;Palette3
                outi                            ;<-(HL++)

                add     a,2                     ;a fazis szamolasa a word cimek miatt kettesevel megy
                cp      25*2                    ;0-24 fazis van, ha tullepte, kezdi 0/tol...
                jr      c,irq1
                ld      (retrace),a             ;...es retrace <- 50, (!= 0)
                xor     a
irq1:           ld      (irqPhase),a            ;irqPhase felso bajt mindig marad 0
                pop     hl
                pop     bc
                pop     af
                out     (CLRINT),a              ;interrupt torlese
                ei
                reti

gameStart:      di
                ld      hl,LA173
                ld      a,50h
                out     (PAGES),a
                ld      a,81h
                out     (SPEAKER),a
;                ld      a,1fh
;                out     (05h),a
;                ld      a,0feh
;                out     (04h),a

                ld      a,0C3h
                ld      (0038h),a
                ld      hl,irq
                ld      (0039h),hl

                ld      sp,STACK
                im      1

                call    clrscr

                xor     a
                out     (BORDER),a
                out     (Palette0),a
                ld      (selected_controller),a
                inc     a
                ld      (demo_level),a
                ld      a,r
                or      80h
                ld      (random+1),a
    if  test = 0
                ei
    else
                ld      a,clRed
                out     (Palette2),a
                ld      a,clWhite
                out     (Palette1),a
                ld      a,clPurple
                out     (Palette3),a
    endif

gs2:            ;call    start_play

                CALL    intro                   ;SOFTWARE PROJECTS
                CALL    stars
                CALL    demo

gs_fame:        CALL    hallOfFame              ;hall of fame (8042)
                CALL    stars
                JR      gs2

play:           call    play0
                ret
                jr      gs_fame

                jr      $

;-----------------------------------------------
;chrout
;  input: A - char
;         B - col
;         C - row
;-----------------------------------------------

chrout:         PUSH    AF
                PUSH    BC
                PUSH    DE
                PUSH    HL

                LD      DE,SCREEN
                LD      H,C
                LD      L,0
                ADD     HL,HL
                ADD     HL,DE
                LD      C,B
                LD      B,0
                ADD     HL,BC
                ADD     HL,BC

                PUSH    HL
                LD      HL,chrgen
                LD      B,00H
                ADD     A,A
                JR      NC,chrout1
                LD      B,04H
chrout1:        ADD     A,A
                JR      NC,chrout2
                SET     1,B
chrout2:        ADD     A,A
                JR      NC,chrout3
                INC     B
chrout3:        LD      C,A
                ADD     HL,BC
                EX      DE,HL
                POP     HL

                LD      B,08H
                push    ix
                ld      ix,bitconv
chrout4:        ld      a,(de)
                rrca
                rrca
                rrca
                rrca
                and     0fh
                ld      (chrout5+2),a
chrout5:        ld      a,(ix+0)
                ld      (hl),a
                inc     hl
                ld      a,(de)
                and     0fh
                ld      (chrout6+2),a
chrout6:        ld      a,(ix+0)
                ld      (hl),a
                inc     de
                LD      A,L
                ADD     A,63
                LD      L,A
                LD      A,H
                ADC     A,0
                LD      H,A
                djnz    chrout4
;               jr      chrout7


;               LD      A,(DE)
;               RRCA
;               RRCA
;               RRCA
;               RRCA
;               AND     A,0FH
;               LD      C,A
;               LD      A,(DE)
;               AND     0F0H
;               OR      C
;               LD      (HL),A
;               INC     HL

;               LD      A,(DE)
;               RLCA
;               RLCA
;               RLCA
;               RLCA
;               AND     A,0F0H
;               LD      C,A
;               LD      A,(DE)
;               AND     0FH
;               OR      C
;               LD      (HL),A
;               LD      A,L
;               ADD     A,63
;               LD      L,A
;               LD      A,H
;               ADC     A,0
;               LD      H,A
;               INC     DE

;               DJNZ    chrout4
;chrout7:
                pop     ix
                POP     HL
                POP     DE
                POP     BC
                POP     AF
                RET

bitconv:        db      000h,011h,022h,033h,044h,055h,066h,077h,088h,099h,0AAh,0BBh,0CCh,0DDh,0EEh,0FFh


;-----------------------------------------------
;get_attr - get attribute (856C)
;set_attr - set attribute (856E)
;  input: B - column
;         C - row
;         A - attribute (01 get attr, 02 rev)
; output: A - attribute (get_attr)
;-----------------------------------------------


orig_attr:      LD      BC,(L98DE)

                ld      a,b
                and     7
                ld      d,a
                ld      a,c
                and     7
                ld      e,a

                srl     b
                srl     b
                srl     b
                srl     c
                srl     c
                srl     c

                call    get_attr
                call    set_attr

                ld      a,d
                or      a
                jr      z,orig_attr1
                inc     b
                call    get_attr
                call    set_attr
                dec     b

orig_attr1:     ld      a,e
                or      a
                ret     z
                inc     c
                call    get_attr
                call    set_attr
                ret

get_attr:       LD      A,1
set_attr:       PUSH    BC
                PUSH    DE
                PUSH    HL

                LD      DE,attr
                LD      L,C
                LD      H,0
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,DE                   ;attribute table row
                LD      D,0
                LD      E,B
                ADD     HL,DE                   ;and col

                cp      2
                jr      z,set_attr_rev

                CP      1
                JR      NZ,set_attr1
                LD      A,(HL)
                POP     HL
                POP     DE
                POP     BC
                RET

set_attr1:      LD      (HL),A
                LD      DE,SCREEN
                LD      H,C
                LD      L,0
                ADD     HL,HL
                ADD     HL,DE
                LD      C,B
                LD      B,0
                ADD     HL,BC
                ADD     HL,BC

                LD      B,8
                LD      C,A
                LD      DE,63
set_attr2:      LD      A,(HL)
                AND     C
                LD      (HL),A
                INC     HL
                LD      A,(HL)
                AND     C
                LD      (HL),A
                ADD     HL,DE
                DJNZ    set_attr2
                LD      A,C

                POP     HL
                POP     DE
                POP     BC
                RET

set_attr_rev:   LD      DE,SCREEN
                LD      H,C
                LD      L,0
                ADD     HL,HL
                ADD     HL,DE
                LD      C,B
                LD      B,0
                ADD     HL,BC
                ADD     HL,BC

                LD      B,8
                LD      C,A
                LD      DE,63
set_attr_rev1:  LD      A,(HL)
                cpl
                LD      (HL),A
                INC     HL
                LD      A,(HL)
                cpl
                LD      (HL),A
                ADD     HL,DE
                DJNZ    set_attr_rev1
                LD      A,C

                POP     HL
                POP     DE
                POP     BC
                RET

;-----------------------------------------------
;textout (8593)
;  input: A: color, D: length
;         B: col, C: row
;         HL: text
;-----------------------------------------------

textout:        PUSH    AF
                LD      A,(HL)
                CALL    chrout
                POP     AF
                CALL    set_attr
                INC     B
                BIT     5,B
                JR      Z,textout1
                LD      B,00H
                INC     C
textout1:       INC     HL
                DEC     D
                JR      NZ,textout
                RET

;-----------------------------------------------
;textout_dbl (8811)
;  input: A: upper row color, E: lower row color, D: length
;         B: row, C: col
;-----------------------------------------------

textout_dbl:    PUSH    AF                      ;save color
                ld      (tmp_color),a
;               CALL    set_attr                ;set color upper row
                LD      A,(HL)                  ;get char
                CP      ' '                     ;space?
                JR      NZ,textout_dbl1
                LD      A,5DH                   ;convert spc
textout_dbl1:   CP      3AH                     ;number?
                JR      NC,textout_dbl2
                ADD     A,3BH                   ;convert numbert to double height number
textout_dbl2:   SUB     41H
                ADD     A,A
                ADD     A,5BH                   ;convert char to double height char
                CALL    chrout                  ;draw upper row
                PUSH    AF
                LD      A,(tmp_color)
                CALL    set_attr                ;set color upper row
                POP     AF
                INC     C                       ;next row
                INC     A                       ;char lower row
                CALL    chrout                  ;draw lower row char
                LD      A,E
                CALL    set_attr                ;set color lwer orw
                POP     AF                      ;restore color
                DEC     C                       ;restore original row
                INC     B                       ;next col
                INC     HL                      ;next char
                DEC     D                       ;length?
                JR      NZ,textout_dbl
                RET

tmp_color:      ds      1

;add_score_play

L9159:          LD      HL,(score_bin)
                ADD     HL,BC
                LD      (score_bin),HL
                LD      A,C
                ADD     A,A
                ADD     A,A
                ADD     A,C
                LD      C,A                     ;mul 5

L9165:          LD      HL,msg_score+6
                LD      B,07H
L916A:          INC     (HL)
                LD      A,(HL)
                CP      3AH
                JR      NZ,L9175
                LD      (HL),30H
                DEC     HL
                DJNZ    L916A

L9175:          DEC     C
                JR      NZ,L9165
                LD      A,0f0h                  ;yellow
                LD      D,07H
                LD      HL,msg_score
                LD      BC,0617H
                CALL    textout
                RET

;-----------------------------------------------

Palette_intro:  db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clGreen
                db      0, clYellow, clCyan, clGreen
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clRed
                db      0, clYellow, clCyan, clRed
                db      0, clYellow, clCyan, clRed
                db      0, clYellow, clCyan, clRed
                db      0, clYellow, clCyan, clRed
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clWhite
                db      0, clWhite, clCyan, clYellow
                db      0, clWhite, clCyan, clYellow
                db      0, clWhite, clCyan, clYellow
                db      0, clWhite, clCyan, clYellow
                db      0, clWhite, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clWhite

intro:          ld      a,81h
                OUT     (SPEAKER),A             ;Beeper off
                CALL    clrscrRnd               ;clear screen random

                ld      de,Palette
                ld      hl,Palette_intro
                ld      bc,24*4
                ldir

;               ld      bc,0
;loop:          ld      a,0ffh
;               ld      d,1
;               ld      hl,txt
;               inc     (hl)
;               call    textout
;               ld      a,c
;               cp      24
;               jr      c,loop

                LD      HL,msg_intro            ;software projects
                LD      BC,0701H
                LD      A,0ffh
                LD      DE,11FFH
                CALL    textout_dbl

                LD      A,0ffh                  ;graphic
                LD      E,05H
                LD      C,04H
intro1:         LD      B,0CH                   ;col
                LD      D,06H
                CALL    textout
                INC     C                       ;next row
                DEC     E
                JR      NZ,intro1

                LD      BC,080BH                ;proudly present
                LD      A,0ffh
                LD      D,0FH
                CALL    textout

                LD      BC,050DH
                LD      D,15H
                CALL    textout                 ;broderbund software's

                LD      DE,0BFFH
                LD      BC,0A0FH
                LD      A,0ffh
                CALL    textout_dbl             ;lode runner

                LD      BC,0512H
                LD      A,0ffh
                LD      D,21
                CALL    textout                 ;spaces

                ret

txt:            db      0ffh

msg_intro:      db      "SOFTWARE PROJECTS"             ;814C

                db      0CEh,0CFh,0D0h,0D1h,0D2h,0D3h   ;graphic 815d
                db      0D4h,0D5h,0D6h,0D7h,0D8h,0D9h
                db      0DAh,0DBh,0DCh,0DDh,0DEh,0D9h
                db      0DFh,0E0h,0E1h,0E2h,0DEh,0D9h
                db      0CEh,0CFh,0E3h,0E4h,0E5h,0E6h

                db      "PROUDLY PRESENT"               ;817B
                db      "BRODERBUND SOFTWARE(S"         ;818A BRODERBUND SOFTWARE'S
                db      "LODE RUNNER"                   ;819F
                db      "  REWRITTEN BY ZKA   "         ;81AA

;-----------------------------------------------
;stars (809B)
;-----------------------------------------------

stars:          LD      HL,star_buff            ;clear star table
                LD      DE,star_buff+1
                LD      (HL),0FFH
                LD      BC,23
                LDIR

                XOR     A                       ;reset timer
                LD      (star_timer),A
stars1:         XOR     A                       ;clear new star flag
                LD      (star_flag),A
                CALL    wait
                CALL    wait
                CALL    wait
                CALL    wait

                ld      hl,star_attr
                ld      (star_attr_ptr),hl

                LD      HL,star_buff            ;star table begin
                LD      B,08H                   ;max stars
stars2:         PUSH    BC
                PUSH    HL
                LD      A,(HL)                  ;free star?
                CP      0FFH
                JR      NZ,stars4               ;not, star visible->

                LD      A,(star_flag)           ;already new star
                AND     A
                JR      NZ,stars7               ;yes, skip->
                INC     A
                LD      (star_flag),A           ;set new star flag

                LD      (HL),00H                ;generate new star, phase = 0
                INC     HL
                CALL    rnd                     ;get random number
                AND     1FH
                LD      B,A                     ;column
stars3:         CALL    rnd                     ;rnd
                AND     1FH
                CP      18H
                JR      NC,stars3               ;row < 24? if not, get new rnd

                LD      C,A                     ;row
                CALL    get_attr                ;position blank?
                AND     A
                JR      NZ,stars3               ;not, get new row

                LD      (HL),C                  ;save row
                INC     HL
                LD      (HL),B                  ;save col

stars3a:        CALL    rnd                     ;get rnd color
                AND     03H                     ;green, cyan, yellow or white star
                jr      z,stars3a
                push    hl
                ld      hl,star_attr_msk
                add     a,l
                ld      l,a
                ld      a,h
                adc     a,0
                ld      h,a
                ld      a,(hl)
                ld      hl,(star_attr_ptr)
                ld      (hl),a
                pop     hl
;               CALL    set_attr

                DEC     HL
                DEC     HL                      ;back to current star begin
                XOR     A                       ;phase=0 on new star

stars4:         INC     HL
                LD      C,(HL)                  ;get row
                INC     HL
                LD      B,(HL)                  ;get col
                CP      05H                     ;star end phase?
                JR      NZ,stars5               ;not yet->

                XOR     A
                CALL    set_attr                ;clear star attr
                DEC     HL
                DEC     HL
                LD      (HL),0FFH               ;mark as free star
                JR      stars7

stars5:         CP      03H                     ;star inc?
                JR      C,stars6                ;yes->
                SUB     03H                     ;convert to dec
                XOR     03H
                SUB     02H
stars6:         CALL    chrout                  ;star out

                push    hl
                ld      hl,(star_attr_ptr)
                ld      a,(hl)
                pop     hl
                call    set_attr

                DEC     HL
                DEC     HL
                INC     (HL)                    ;next star phase

stars7:         POP     HL
                INC     HL
                INC     HL
                INC     HL                      ;go to next star in buffer
                POP     BC
                push    hl
                ld      hl,(star_attr_ptr)
                inc     hl
                ld      (star_attr_ptr),hl
                pop     hl
                dec     b
                JP      NZ,stars2               ;8 stars in buffer

                LD      HL,star_timer           ;decrement timer
                DEC     (HL)
                RET     Z                       ;time out?

                ld      a,(hl)
                and     3
                jr      nz,stars10
                ld      hl,(blinkRow)
                ld      a,h
                or      l
                jr      z,stars10
                ld      a,(hl)
                xor     40h
                ld      (hl),a

stars10:        CALL    test_kbd                ;test keyboard
                CP      0FFH                    ;key pressed
                JR      Z,stars8                ;not->
                POP     BC
stars_exit:     JP      menu                    ;exit

stars8:         CALL    test_fire
                LD      A,D
                AND     A
                JR      Z,stars9
                POP     BC
                JP      menu

stars9:         JP      stars1                  ;continue star show

star_timer:     ds      1
star_flag:      ds      1

lives:          db      005h    ;9186: .

score_bin:      dw      0       ;9187: ..
msg_score:      db      "0000000"       ;9189: 00

empty_name:     db      "        "      ;empty name

L9198:
lastHighScoreRow:
                db      5

level:          db      001h    ;9199: level
L919A:          db      004h    ;enemy count
L919B:          db      014h    ;self row
L919C:          db      011h    ;self col

L91B5:          db      006h    ;91B5: .
chests:         db      006h

L919D:
star_buff:      ds      24      ;8*[phase,col,row]
star_attr:      ds      8
star_attr_ptr:  ds      2
star_attr_msk:  db      000h,00Fh,0F0h,0FFh
blinkRow:       dw      0

;----------------------------------------------------------------------------
; rnd - veletlenszam generalasa
;
; output: A - veletlenszam
;
; RNDn := (RNDn-1 + RNDn-4 + RNDn-5) Mod 256
;
;----------------------------------------------------------------------------

rnd:            push    ix
                push    hl
                push    de
                push    bc
                ld      ix,random
                ld      a,(ix+1)
                adc     a,(ix+4)
                adc     a,(ix+5)
                ld      (random),a
                ld      hl,random + 4
                ld      de,random + 5
                ld      bc,5
                lddr
                pop     bc
                pop     de
                pop     hl
                pop     ix
                ret

random:         ds      6

wait:           push    af
                xor     a
                ld      (retrace),a
wait1:          ld      a,(retrace)
                 or      a
    if test = 0
                jr      z,wait1
    endif
                pop     af
                ret

;-----------------------------------------------
;clrscrRnd (854F)
;-----------------------------------------------

clrscrRnd:      ld      de,1024
clrscrRnd1:     call    rnd
                and     a,1Fh
                ld      b,a
                call    rnd
                and     1fh
                cp      24
                jr      nc,clrscrRnd1
                ld      c,a
                ld      a,0
                call    set_attr
                dec     de
                ld      a,d
                or      e
                jr      nz,clrscrRnd1

;-----------------------------------------------
;clrscr (8541)
;-----------------------------------------------

clrscr:         LD      DE,VRAM+1
                LD      HL,VRAM
                LD      (HL),00H
                LD      BC,16384
                LDIR

                LD      DE,attr+1
                LD      HL,attr
                LD      (HL),00H
                LD      BC,767
                LDIR

                ld      hl,0
                ld      (blinkRow),hl
                RET

;-----------------------------------------------
getkey:         out     (03h),a
                nop
                nop
                in      a,(58h)
                ret

test_kbd:       ld      bc,0affh
test_kbd1:      ld      a,b
                dec     a
                call    getkey
                and     c
                ld      c,a
                djnz    test_kbd1
                ret

read_kbd:       push    bc
                push    de
                push    hl
                ld      bc,0ffh
                ld      hl,kbdtable
read_kbd1:      ld      a,b
                call    getkey
                ld      d,a
                ld      e,01h
read_kbd2:      ld      a,d
                and     e
                jr      z,read_kbd4
                inc     hl
                rl      e
                jr      nc,read_kbd2
                inc     b
                ld      a,b
                cp      8
                jr      c,read_kbd1
read_kbd3:      ld      a,0ffh
                jr      read_kbd5

read_kbd4:      ld      a,(hl)
                cp      '?'
                jr      z,read_kbd3
read_kbd5:      pop     hl
                pop     de
                pop     bc
                ret

kbdtable:       db      "53206?14?89????7TEW?Z?QR?IO???PUGDS?H?AF"
                db      "bKL?e??JBCX?N?YV?????p?M????????????????"

;-----------------------------------------------
;menu
;-----------------------------------------------
menu:           CALL    clrscrRnd               ;clear screen
                call    menu_setpal

                ld      a,81h
                OUT     (SPEAKER),A             ;disable speaker
;               LD      (L5C48),A

                LD      IX,ctrl_menu
                LD      BC,0100H
                LD      DE,1DFFH
                LD      A,0ffh
                LD      HL,msg_menu
                CALL    textout_dbl             ;LODE RUNNER -  GAME SELECTION

menu1:          LD      B,07H                   ;col=7
                LD      A,(IX+00H)              ;color
                CP      0FFH                    ;end of list?
                JR      Z,menu2                 ;if end,->
                INC     IX
                LD      C,(IX+00H)              ;get row
                INC     IX
                LD      D,(IX+00H)              ;get length
                INC     IX
                ld      a,0ffh
                CALL    textout
                JR      menu1

menu2:          LD      A,(selected_controller)
                ADD     A,A                     ;calculate row (controller * 2 + 4)
                ADD     A,4
                add     a
                add     a
                ld      c,a
                ld      b,0
                ld      hl,Palette+3
                add     hl,bc
                ld      a,clCyan
                ld      (hl),a

menu4:          CALL    read_kbd

menu9:          CP      30H                     ;start game
                JP      Z,L8A26
                CP      34H                     ;redefine keys
                JP      Z,redefine
                CP      31H
                JR      C,menu4
                CP      34H
                JR      NC,menu4
                SUB     31H
                LD      HL,selected_controller
                CP      (HL)
                JR      Z,menu4
                LD      (HL),A
                call    menu_setpal
                JP      menu2

menu_setpal:    ld      hl,Palette_menu
                ld      de,Palette+3
                ld      bc,24
menu_setpal1:   ldi
                inc     de
                inc     de
                inc     de
                jp      pe,menu_setpal1
                ret

selected_controller:
                ds      1

msg_menu:       db      "LODE RUNNER -  GAME SELECTION"
                db      "1 KEYBOARD"
                db      "2 JOYSTICK 1"
                db      "3 JOYSTICK 2"
                db      "4 REDEFINE KEYS"
                db      "0 START GAME"

                ;control for menu items: color, row, length
ctrl_menu:      db      007h,004h,00Ah
                db      007h,006h,00Ch
                db      007h,008h,00Ch
                db      007h,00Ah,00Fh
                db      006h,00Dh,00Ch
                db      0FFh

Palette_menu:   db      clGreen,clGreen
                db      clWhite,clWhite,clWhite,clWhite,clWhite,clWhite,clWhite,clWhite,clWhite
                db      clYellow,clYellow,clYellow,clYellow,clYellow,clYellow,clYellow,clYellow
                db      clYellow,clYellow,clYellow,clYellow,clYellow

;-----------------------------------------------
;hallOfFame (9101)
;-----------------------------------------------

hallOfFame:     CALL    clrscrRnd
                ld      de,Palette
                ld      hl,Palette_hof
                ld      bc,24*4
                ldir

                LD      A,0ffh
                LD      HL,msg_halloffame
                LD      BC,0A03H
                LD      DE,0BFFH
                CALL    textout_dbl             ;lode runner

                LD      BC,0912H
                LD      A,0ffh
                LD      DE,0CFFH
                CALL    textout_dbl             ;hall of fame

                LD      C,07H
                LD      E,05H
                LD      HL,highScores
                ld      ix,Palette + 7*4 + 3
                LD      A,0ffh
hallOfFame1:    PUSH    DE
                LD      B,A
                LD      A,(lastHighScoreRow)    ;last high score row
                CP      E
                JR      NZ,hallOfFame2
                ld      (blinkRow),ix
hallOfFame2:    LD      A,0ffh
                INC     HL
                INC     HL
                LD      B,07H
                CALL    set_attr
                INC     B
                LD      D,07H
                CALL    textout
                CALL    set_attr
                INC     B
                CALL    set_attr
                INC     B
                CALL    set_attr
                INC     B
                LD      D,08H
                CALL    textout
                INC     C
                INC     C
                ld      de,8
                add     ix,de
                POP     DE
                DEC     E
                JR      NZ,hallOfFame1
                RET

msg_halloffame: db      "LODE RUNNER"
                db      "HALL OF FAME"

Palette_hof:    db      0, clWhite, clYellow, clCyan
                db      0, clGreen, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan
                db      0, clGreen, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan
                db      0, clGreen, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan
                db      0, clYellow, clCyan, clWhite
                db      0, clYellow, clCyan, clWhite
                db      0, clWhite, clCyan, clYellow
                db      0, clWhite, clCyan, clYellow
                db      0, clWhite, clYellow, clCyan
                db      0, clGreen, clYellow, clCyan
                db      0, clYellow, clCyan, clGreen
                db      0, clYellow, clCyan, clGreen
                db      0, clYellow, clCyan, clPurple
                db      0, clYellow, clCyan, clPurple
                db      0, clWhite, clYellow, clCyan
                db      0, clGreen, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan
                db      0, clGreen, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan
                db      0, clGreen, clYellow, clCyan
                db      0, clWhite, clYellow, clCyan


L91B7:
highScores:
highScore1:     dw      4000
                db      "0020000","JOHN    "
highScore2:     dw      3000
                db      "0015000","PAUL    "
highScore3:     dw      2000
                db      "0010000","JAMES   "
highScore4:     dw      1000
                db      "0005000","ROY     "
highScore5:     dw      200
                db      "0001000","NANCY   "

;-----------------------------------------------
;redefine - redefine keys
;-----------------------------------------------

redefine:       CALL    clrscrRnd
                ld      hl,Palette+3
                ld      de,4
                ld      b,10
redefine1:      ld      (hl),clWhite
                add     hl,de
                djnz    redefine1
                ld      b,14
redefine2:      ld      (hl),clCyan
                add     hl,de
                djnz    redefine2

                XOR     A
                LD      (selected_controller),A
                LD      HL,msg_redefine
                LD      D,16H
                LD      A,0ffh
                LD      BC,0507H
                CALL    textout

                LD      C,0AH
                LD      E,05H
                LD      A,0ffh
redefine3:      LD      B,0CH
                LD      D,05H
                CALL    textout
                INC     C
                INC     C
                DEC     E
                JR      NZ,redefine3

                LD      B,05H
redefine4:      LD      (HL),0FFH
                INC     HL
                DJNZ    redefine4

                LD      A,00H
redefine5:      PUSH    AF
                AND     A
                JR      Z,redefine6
                DEC     A
                ld      d,clCyan
                call    redef_attr

redefine6:      POP     AF
                PUSH    AF
                ld      d,clRed
                call    redef_attr

redefine7:      CALL    read_kbd
                CP      0FFH
                JR      NZ,redefine7
redefine8:      CALL    read_kbd
                CP      0FFH
                JR      Z,redefine8
                CP      'e'
                JR      Z,redefine7
                CP      'b'
                JR      Z,redefine7

                LD      HL,sel_keys
                LD      B,05H
                LD      (curr_key),A
                LD      E,A
redefine9:      LD      A,(HL)
                CP      0FFH
                JR      NZ,redefine10
                LD      (HL),E
                JR      redefine11

redefine10:     CP      E
                JR      Z,redefine7
                INC     HL
                DJNZ    redefine9

redefine11:     ;LD      HL,LA2ED
                POP     AF
                PUSH    AF
                ADD     A,A
                ADD     A,0AH
                LD      C,A
                LD      A,(curr_key)
                CP      5BH
                JR      NC,redefine12
                LD      B,13H
                CALL    chrout
                JR      redefine13

redefine12:     ld      hl,msg_spc
                LD      B,12H
                LD      A,0ffh
                LD      D,03H
                CALL    textout

redefine13:     ;LD      HL,03E8H*3125/3547
                ;LD      DE,0032H
                ;CALL    BEEPER
                ld      hl,3651                 ;440Hz
                ld      de,310*7                ;1/60sec
                call    piano

                POP     AF
                INC     A
                CP      05H
                JP      NZ,redefine5

                LD      HL,msg_ok
                LD      A,0ffh
                LD      BC,0815H
                LD      D,11H
                CALL    textout

                ld      a,clCyan
                ld      (Palette+3+18*4),a
                ld      a,clYellow
                ld      (Palette+3+21*4),a

redefine14:     CALL    read_kbd
                CP      0FFH
                JR      NZ,redefine14
redefine15:     CALL    read_kbd
                CP      'N'
                JP      Z,redefine
                CP      'Y'
                JP      Z,menu
                JR      redefine15

redef_attr:     ADD     A,A
                ADD     A,0AH
                ADD     A,A
                ADD     A,A
                LD      C,A
                ld      b,0
                ld      hl,Palette+3
                add     hl,bc
                ld      (hl),d
                ret

msg_redefine:   db      "PLEASE SELECT KEYS FOR"
                db      "LEFT "
                db      "RIGHT"
                db      "UP   "
                db      "DOWN "
                db      "FIRE "
sel_keys:       db      "OPQAp"

;LA2ED:          dw      L8743
;                dw      L874D
;                dw      L87B4
;                dw      L87B4
;                dw      L87E5

key_left        equ     sel_keys+0
key_right       equ     sel_keys+1
key_up          equ     sel_keys+2
key_down        equ     sel_keys+3
key_fire        equ     sel_keys+4

msg_ok:         db      "OK ? -  YES OR NO"
msg_spc:        db      "SPC"
curr_key:       db      000h    ;A1D8: .

;-----------------------------------------------
;demo - Palette: black red white purple
;-----------------------------------------------

demo:           CALL    clrscrRnd
                call    set_demoPalette
                CALL    clrScore                        ;clear scores
                XOR     A
                LD      (lives),A
                LD      A,(demo_level)
                PUSH    AF
                ADD     A,05H
                CP      MAX_LEVEL+1
                JR      NZ,demo1
                LD      A,01H
demo1:          LD      (demo_level),A
                XOR     A
                LD      (L8F74),A
                LD      (L8F91),A
                POP     AF
                LD      C,A

                LD      B,05H
demo2:          PUSH    BC
                LD      A,C
                LD      (level),A
                PUSH    AF
                ld      a,1
                ld      (disable_bar),a
                CALL    footer                  ;footer

                LD      BC,0016H                ;col=2, row=22
                LD      HL,msg_pressanykey
                LD      D,20H                   ;length=32
                LD      A,0ffh                  ;color=purple
                CALL    textout                 ;press any key for main menu
                xor     a
                ld      (disable_bar),a

                POP     AF
                CALL    room_addr               ;get room address
                CALL    draw_room

                LD      B,100                   ;2 sec wait
demo3:          call    wait
                DJNZ    demo3
                POP     BC
                INC     C
                DJNZ    demo2
                RET

set_demoPalette:
                ld      ix,Palette
                ld      de,4
                ld      b,24
set_demoPalette1:
                ld      (ix+1),clWhite
                ld      (ix+2),clRed
                ld      (ix+3),clWhite
                add     ix,de
                djnz    set_demoPalette1
                ld      (ix-5),clPurple
                ret


msg_pressanykey:db      005h,005h,"PRESS",005h,"ANY",005h,"KEY",005h,"FOR",005h,"MAIN",005h,"MENU",005h,005h,005h
demo_level:     db      1                       ;820A

;-----------------------------------------------
;clrScore (8A10)
;-----------------------------------------------

clrScore:       LD      HL,"00"
                LD      (msg_score),HL
                LD      (msg_score+2),HL
                LD      (msg_score+4),HL
                LD      (msg_score+5),HL
                LD      HL,0
                LD      (score_bin),HL
                RET

;-----------------------------------------------
; footer (8226)
;-----------------------------------------------

footer:         push    ix
                ld      ix,Palette + 23*4
                ld      (ix+1),clCyan
                ld      (ix+2),clYellow
                pop     ix

                LD      BC,0017H                ;col=0, row=23
                LD      D,20H                   ;length=32
                LD      A,0fh                   ;color: cyan
                LD      HL,msg_footer
                CALL    textout

                LD      HL,0                    ;convert level to ascii
                LD      A,(level)
footer1:        CP      10
                JR      C,footer2
                SUB     10
                INC     H
                JR      footer1

footer2:        ADD     A,'0'
                LD      BC,1F17H
                CALL    chrout                  ;level lower digit
                DEC     B                       ;prev col
                LD      A,H
                ADD     A,'0'
                CALL    chrout                  ;level upper digit

                LD      A,0f0h                  ;color=yellow
                CALL    set_attr
                INC     B
                CALL    set_attr

                LD      B,16H                   ;convert lives to ascii
                LD      A,(lives)
                LD      H,0
footer3:        CP      100
                JR      C,footer4
                SUB     100
                INC     H
                JR      footer

footer4:        CP      10
                JR      C,footer5
                SUB     10
                INC     L
                JR      footer4

footer5:        ADD     A,"0"                   ;draw lives
                CALL    chrout
                DEC     B
                LD      A,L
                ADD     A,'0'
                CALL    chrout
                DEC     B
                LD      A,H
                ADD     A,'0'
                CALL    chrout

                LD      A,0f0h                  ;color=yellow
                CALL    set_attr
                INC     B
                CALL    set_attr
                INC     B
                CALL    set_attr

                LD      D,07H                   ;draw score
                LD      B,06H
                LD      HL,msg_score
                CALL    textout

                ld      a,(disable_bar)
                or      a
                ret     nz

                LD      BC,0016H                ;purple bar
footer6:        LD      A,05H
                CALL    chrout
                LD      A,0ffh
                CALL    set_attr
                INC     B
                BIT     5,B
                JR      Z,footer6
                RET

msg_footer:     db      "SCORE         "        ;82B0
                db      "LIVES     "
                db      "LEVEL   "
disable_bar:    db      0

;-----------------------------------------------
;get room address from level
;  input: A: level
;  output: HL: room address
;-----------------------------------------------

room_addr:      LD      L,A             ;mul 264
                LD      H,00H
                LD      B,03H
room_addr1:     ADD     HL,HL
                DJNZ    room_addr1
                PUSH    HL
                POP     DE
                LD      B,05H
room_addr2:     ADD     HL,HL
                DJNZ    room_addr2
                ADD     HL,DE
                LD      DE,rooms
                ADD     HL,DE
                RET

;-----------------------------------------------
; draw_room (8DE9)
;-----------------------------------------------

draw_byte_rlc:  rlca
                rlca
                rlca
draw_byte:      ld      d,a
                push    de
                push    bc
                push    hl
                and     7
                CALL    draw_element            ;draw room element
                pop     hl
                pop     bc
                INC     B                       ;next col
                BIT     5,B
                scf
                jr      z,draw_byte1

                ld      b,0
                INC     C                       ;next row
                LD      A,C
                CP      16H
draw_byte1:     pop     de
                ld      a,d
                ret


draw_room:
    if  allmaps = 1
                call    memp2in
    endif

                LD      DE,tmp_room
                LD      BC,0108H
                LDIR
    if  allmaps = 1
                call    vidpgin
    endif

                ld      hl,tmp_room
                LD      C,00H                   ;row=0
dr1:            LD      B,00H                   ;col=0

;               00011122 23334445 55666777

drloop:         ld      a,(hl)                  ;000
                inc     hl
                call    draw_byte_rlc

                call    draw_byte_rlc           ;111

                ld      e,(hl)                  ;222
                inc     hl
                rlca
                rlca
                rlc     e
                rla
                call    draw_byte
                ld      a,e

                call    draw_byte_rlc           ;333

                call    draw_byte_rlc           ;444

                ld      e,(hl)                  ;555
                inc     hl
                rlca
                rlc     e
                rla
                rlc     e
                rla
                call    draw_byte
                ld      a,e

                call    draw_byte_rlc           ;666

                call    draw_byte_rlc           ;777
                jr      c,drloop

;               EI
dr5:
                LD      A,(level)
                LD      L,A
                LD      H,00H
                ADD     HL,HL
                ADD     HL,HL
                PUSH    HL
                POP     DE
                ADD     HL,HL
                ADD     HL,DE                   ;HL=level*12
                LD      DE,LAF18
                ADD     HL,DE                   ;room init table
    if  allmaps = 1
                call    memp2in
    endif
                LD      A,(HL)                  ;self row
                LD      (L919B),A
                INC     HL
                LD      A,(HL)                  ;self x pos
                LD      B,A
                AND     07H
                LD      (L919A),A               ;enemy count
                LD      A,B
                SRL     A
                SRL     A
                SRL     A
                LD      (L919C),A               ;self col
                INC     HL

                LD      DE,L919D
                LD      BC,000AH
                LDIR
    if  allmaps = 1
                call    vidpgin
    endif

                LD      BC,(L919B)              ;self row col
                LD      A,1EH                   ;self char
                CALL    chrout
                LD      A,0f0h                  ;white self
                CALL    set_attr

                LD      A,(L919A)               ;enemy count
                LD      D,A
                LD      HL,L919D                ;room init table
L8E6E:          LD      C,(HL)                  ;get enemy row and col
                INC     HL
                LD      B,(HL)
                INC     HL
                LD      A,1EH
                CALL    chrout
;                LD      A,0ffh                  ;purple enemy
                LD      A,0f0h                  ;white enemy
                CALL    set_attr
                DEC     D
                JR      NZ,L8E6E
                RET

;-----------------------------------------------
;draw_element - draw room one char
;  inputs: B: col, C: row, A: element
;-----------------------------------------------

draw_element:
L8F56:          PUSH    BC
                LD      HL,LAB32                ;emenets table
                LD      E,B
                LD      D,00H
                ADD     HL,DE
                SLA     C
                SLA     C
                SLA     C
                SLA     C
                JR      NC,L8F6A
                INC     H
                INC     H
L8F6A:          SLA     C
                JR      NC,L8F6F
                INC     H
L8F6F:          LD      B,00H
                ADD     HL,BC
                LD      (HL),A                  ;store element
                JR      L8F75
L8F74           equ     $-1

L8F75:          CP      05H
                JR      NZ,L8F7B
                LD      A,01H
L8F7B:          CP      06H
                JR      NZ,L8F80
                XOR     A
L8F80:          ADD     A,20H
                POP     BC
                CALL    chrout
                SUB     20H
                LD      E,A
                LD      HL,room_colors
                ADD     HL,DE
                LD      A,(HL)
                CALL    set_attr
L8F91:          RET

L8F92:          PUSH    BC
                CALL    read_kbd
                CP      0FFH
                POP     BC
                RET     Z
                POP     BC
                POP     BC
                POP     BC
                EI
                JP      menu

room_colors:    db      0f0h,00fh,00fh,0f0h,0f0h,0f0h,0f0h,0f0h,0ffh,0f0h
;               db      047h,042h,042h,047h,047h,045h,044h,046h,043h,007h       ;8DDE: .GBBGGEDFC.

;-----------------------------------------------
;test_fire - test fire key (87DB)
;  output: D=0 none, D=1 down, D=-1 up
;-----------------------------------------------

test_fire:      LD      D,00H
                LD      A,(selected_controller)
                AND     A
                JR      NZ,test_fire2

                ;keyboard
                call    read_kbd
                ld      c,a
                ld      a,(key_fire)
                cp      c
                ret     nz
test_fire1:     INC     D
                RET

test_fire2:     CP      02H
                ld      a,9
                JR      Z,test_fire3

                ;joy 1
                ld      a,7
                call    getkey
                bit     5,a
                jr      z,test_fire1
                ld      a,8
test_fire3:     call    getkey
                bit     3,a
                jr      z,test_fire1
                ret

;-----------------------------------------------
;test_lr - test left and right keys (8739)
;  output: D=0 none, D=1 right, D=-1 left
;-----------------------------------------------

test_lr:        LD      A,(selected_controller)
                AND     A
                LD      D,00H                   ;clear result
                JR      NZ,test_lr2

                ;keyboard
                call    read_kbd
                ld      c,a
                ld      a,(key_right)
                cp      c
                jr      nz,test_lr1
                INC     D
test_lr1:       ld      a,(key_left)
                cp      c
                ret     nz
                DEC     D
                RET

test_lr2:       CP      02H
                ld      a,9
                JR      Z,test_lr3              ;joy 2

                ;joy1
                dec     a
test_lr3:       call    getkey
                BIT     5,A                     ;right?
                JR      Z,test_lr4
                DEC     D
test_lr4:       BIT     6,A                     ;left?
                RET     Z
                INC     D
                RET

;-----------------------------------------------
;test_ud - test left and right keys (87AA)
;  output: D=0 none, D=1 down, D=-1 up
;-----------------------------------------------

test_ud:        LD      A,(selected_controller)
                AND     A
                LD      D,00H                   ;clear result
                JR      NZ,test_ud2

                ;keyboard
                call    read_kbd
                ld      c,a
                ld      a,(key_down)
                cp      c
                jr      nz,test_ud1
                INC     D
test_ud1:       ld      a,(key_up)
                cp      c
                ret     nz
                DEC     D
                RET

test_ud2:       CP      02H
                ld      a,9
                JR      Z,test_ud3              ;joy 2

                ;joy1
                dec     a
test_ud3:       call    getkey
                BIT     2,A                     ;down?
                JR      Z,test_ud4
                DEC     D
test_ud4:       BIT     1,A                     ;up?
                RET     Z
                INC     D
                RET

;;-----------------------------------------------
;;BEEPER
;;-----------------------------------------------
;
;BEEPER:         ld      a,l
;                srl     l
;                srl     l
;                cpl
;                and     3
;                ld      c,a
;                ld      b,0
;                ld      ix,beeper1
;                add     ix,bc
;                ld      a,1fh
;                out     (05h),a
;                ld      a,0feh
;                out     (04h),a
;                ld      a,81h
;                di
;beeper1:        nop
;                nop
;                nop
;                inc     b
;                inc     c
;beeper2:        dec     c
;                jr      nz,beeper2
;                ld      c,3fh
;                dec     b
;                jp      nz,beeper2
;
;                xor     3ch
;                out     (SPEAKER),a
;
;                ld      b,h
;                ld      c,a
;                bit     4,a
;                jr      nz,beeper3
;                ld      a,d
;                or      e
;                jr      z,beeper4
;                ld      a,c
;                ld      c,l
;                dec     de
;                jp      (ix)
;
;beeper3:        ld      c,l
;                inc     c
;                jp      (ix)
;
;beeper4:        ei
;                ret

;-----------------------------------------------
;start_play (8FA1)
;-----------------------------------------------

start_play:     CALL    clrscrRnd
                CALL    footer
                LD      A,(level)
                CALL    room_addr
                CALL    draw_room

;blink self figure

start_play1:    LD      BC,(L919B)              ;self row col
                LD      A,00H
                CALL    set_attr

                LD      B,05H
start_play2:    call    wait
                DJNZ    start_play2

                LD      BC,(L919B)              ;self row col
                LD      A,1EH                   ;self char
                CALL    chrout
                LD      A,0f0h                  ;white self
                CALL    set_attr

                LD      B,05H
start_play3:    call    wait
                PUSH    BC
                CALL    read_kbd
                INC     A
                LD      E,A
                CALL    test_fire
                LD      A,D
                OR      E
                POP     BC
                JR      NZ,start_play4
                DJNZ    start_play3
                JR      start_play1

start_play4:    CALL    play
                RET

;-----------------------------------------------
;Start Game
;-----------------------------------------------

L8A26:          CALL    clrScore                ;set score = 000000
                LD      A,1
                LD      (level),A               ;set level = 1
                LD      A,5
                LD      (lives),A               ;set lives = 5

                XOR     A
                LD      (L8F74),A
                LD      A,0C9H                  ;RET
                LD      (L8F91),A

                CALL    clrscrRnd
                call    set_demoPalette
                LD      BC,0A0BH
                LD      DE,0DF0H
                LD      A,0F0H
                LD      HL,L8BB2
                CALL    textout_dbl             ;press any key

                LD      B,25                    ;0.5s wait
game1:          call    wait
                DJNZ    game1

game2:          CALL    read_kbd
                CP      0FFH
                JR      Z,game2

game3:          CALL    start_play
                AND     A
                JR      NZ,game4
                LD      HL,lives
                DEC     (HL)
                JR      NZ,game3
                JP      game_over

game4:          LD      HL,level
                INC     (HL)
                LD      A,(HL)
                LD      HL,lives
                INC     (HL)
                JR      NZ,game5
                DEC     (HL)
game5:          CP      MAX_LEVEL+1
                JR      NZ,game3

                CALL    clrscrRnd

                ld      hl,final_Palette
                ld      de,Palette+3
                ld      bc,22
game6:          ldi
                inc     de
                inc     de
                inc     de
                jp      pe,game6

                CALL    footer
                LD      BC,0C02H
                LD      DE,09FFH
                LD      A,0FFH
                LD      HL,L8B27
                CALL    textout_dbl             ;made it..

                LD      HL,L8B70
                LD      BC,0109H
                LD      D,1FH
                LD      A,0ffh                  ;yellow
                CALL    textout                 ;bonus

                LD      BC,060CH
                LD      DE,0Cffh
                LD      A,0ffh                  ;cyan
                CALL    textout_dbl             ;final score

game7:          LD      HL,lives
                DEC     (HL)
                LD      BC,50
                CALL    add_score
                LD      BC,50
                CALL    add_score
                CALL    footer
                LD      DE,07FFH
                LD      BC,130CH
                LD      A,0ffh
                LD      HL,msg_score
                CALL    textout_dbl

                ld      hl,1f6bh
                ld      a,81h+1ch
                ld      c,PITCHL
                out     (c),l
                inc     c
                out     (c),h
                inc     c
game8:          out     (c),a
                call    delay
                sub     4
                cp      81h
                jr      nc,game8

;               LD      HL,03E8H
;               LD      DE,0064H
;               CALL    BEEPER
                call    wait

                LD      HL,lives
                LD      A,(HL)
                AND     A
                JR      NZ,game7

                LD      HL,L8B9C
                LD      A,0ffh
                LD      DE,09FFH
                LD      BC,0B10H
                CALL    textout_dbl             ;well done

                LD      BC,0914H
                LD      A,0ffh
                LD      D,0DH
                CALL    textout                 ;press any key

                LD      HL,game_exit
                LD      (stars_exit+1),HL
                CALL    stars
game_exit:      LD      HL,menu
                LD      (stars_exit+1),HL
                jr      game_over2

game_over:      LD      BC,0B0BH
                LD      DE,09F0H
                LD      HL,L8BBF
                LD      A,0f0h
                CALL    textout_dbl             ;game over
                LD      B,200
game_over1:     call    wait
                DJNZ    game_over1

game_over2:     LD      DE,(highScore5)
                LD      HL,(score_bin)
                LD      IX,score_bin
                SCF
                SBC     HL,DE
                CALL    P,game_over3
                JP      gs_fame

game_over3:     CALL    clrscrRnd
                ld      iy,Palette+3
                ld      (iy+5*4),clWhite
                ld      (iy+7*4),clWhite
                ld      (iy+9*4),clWhite
                ld      (iy+13*4),clYellow
                ld      (iy+15*4),clCyan

                LD      IY,L905E
                LD      HL,L9000
                LD      B,05H
game_over4:     PUSH    BC                      ;congratulations
                LD      A,0ffh
                LD      B,(IY+01H)
                LD      C,(IY+02H)
                LD      D,(IY+03H)
                CALL    textout
                LD      E,4
                ADD     IY,DE
                POP     BC
                DJNZ    game_over4

                LD      BC,0C0FH
                CALL    get_name                ;get name
                LD      IY,highScore4
                PUSH    IX                      ;current score
                POP     HL
                LD      DE,highScore5
                LD      BC,0011H
                LDIR

                LD      B,01H
game_over5:     PUSH    BC
                LD      L,(IY+00H)              ;high score
                LD      H,(IY+01H)
                LD      E,(IX+00H)              ;current score
                LD      D,(IX+01H)
                AND     A
                SBC     HL,DE
                JR      C,game_over7
                POP     BC
game_over6:     LD      A,B
                LD      (lastHighScoreRow),A
                RET

game_over7:     PUSH    IY
                POP     HL
                PUSH    HL
                LD      BC,0011H
                ADD     HL,BC
                EX      DE,HL
                POP     HL
                LDIR
                PUSH    IY
                POP     DE
                PUSH    IX
                POP     HL
                LD      BC,0011H
                LDIR
                LD      B,11H
game_over8:     DEC     IY
                DJNZ    game_over8
                POP     BC
                INC     B
                LD      A,05H
                CP      B
                JR      NZ,game_over5
                JR      game_over6

L9000:          db      "CONGRATULATIONS"
                db      "YOU HAVE SCORED ONE OF TODAY(S"
                db      "TOP HIGH SCORES"
                db      "PLEASE ENTER YOUR NAME"
                db      "<<        >>"

L905E:          db      007h,008h,005h,00Fh
                db      007h,001h,007h,01Eh
                db      007h,008h,009h,00Fh
                db      006h,005h,00Dh,016h
                db      005h,00Ah,00Fh,00Ch


L8B27:          db      "MADE IT.."
L8B70:          db      "BONUS :  500 PER LIFE REMAINING"
                db      "FINAL SCORE."
L8BBF:          db      "GAME OVER"
L8B9C:          db      "WELL DONE"
L8BB2:          db      "PRESS ANY KEY"

final_Palette:  db      clWhite,clWhite,clWhite,clWhite,clWhite,clWhite,clWhite,clWhite
                db      clYellow,clYellow,clCyan,clCyan,clCyan,clCyan,clCyan,clCyan
                db      clRed,clRed,clPurple,clPurple,clPurple,clPurple

delaybc         push    bc
                jr      delay2
delay:          push    bc
                ld      bc,1024
delay2          push    af
delay1:         dec     bc
                ld      a,b
                or      c
                jr      nz,delay1
                pop     af
                pop     bc
                ret

tick:           push    af
                push    bc
                push hl
                ld      hl,1f22h
                ld      a,81h+1ch
                ld      c,PITCHL
                out     (c),l
                inc     c
                out     (c),h
                inc     c
                out     (c),a
                call    delay
                ld      a,81h
                out     (c),a
                pop     hl
                pop     bc
                pop     af
                ret


get_name:       LD      HL,empty_name
                PUSH    BC
                LD      D,08H
                CALL    textout
                POP     BC
                ld      a,2
                CALL    set_attr                ;rev

                LD      A,01H
                LD      HL,empty_name
L8855:          PUSH    AF
                PUSH    BC
L8857:          CALL    read_kbd
                CP      0FFH
                JR      Z,L8857

                call    tick

                CP      'e'
                JR      Z,L88D8
                CP      'p'
                JR      NZ,L8868
                LD      A,20H
L8868:          CP      'b'
                JR      NZ,L88A5
                POP     BC
                POP     AF
                DEC     A
                JR      NZ,L8882
                INC     A
                PUSH    AF
                PUSH    BC
                JR      L88C8

L8882:          DEC     HL
                LD      (HL),20H
                DEC     B
                PUSH    AF
                PUSH    BC
                LD      A,20H
                CALL    chrout
                ld      a,0ffh
                CALL    set_attr
                ld      a,02h
                CALL    set_attr                ;rev
                INC     B
                ld      a,02h
                CALL    set_attr                ;rev
L889B:          call    read_kbd
                inc     a
                jr      nz,L889B
                JR      L88C8

L88A5:          POP     BC
                LD      D,A
                POP     AF
                CP      09H
                JR      Z,L88C6
                PUSH    AF
                LD      A,D
                CALL    chrout
                LD      (HL),A
                INC     HL
                ld      a,0ffh
                CALL    set_attr
                INC     B
                ld      a,02h
                CALL    set_attr
                POP     AF
                INC     A
L88C6:          PUSH    AF
                PUSH    BC
L88C8:          CALL    read_kbd
                inc     a
                JR      NZ,L88C8
L88D3:          POP     BC
                POP     AF
                JP      L8855

L88D8:          POP     BC
                EX      DE,HL
                POP     AF
                ld      a,02h
                CALL    set_attr
                RET


;input: BC: score to add
add_score:      LD      HL,(score_bin)
                ADD     HL,BC
                LD      (score_bin),HL
                LD      A,C
                ADD     A,A
                ADD     A,A
                ADD     A,C
                LD      C,A
add_score1:     LD      HL,msg_score+6
                LD      B,07H
add_score2:     INC     (HL)
                LD      A,(HL)
                CP      3AH
                JR      NZ,add_score3
                LD      (HL),30H
                DEC     HL
                DJNZ    add_score2
add_score3:     DEC     C
                JR      NZ,add_score1
                LD      A,0f0h                  ;yellow
                LD      D,07H
                LD      HL,msg_score
                LD      BC,0617H
                CALL    textout
                RET

;-----------------------------------------------
;piano
;  inputs: HL - pitch, DE - duration
;  pitch: 4095 - (3125000 / 16 / freq)
;   195312,5 / (4096 - pitch) 
;   3546895 / hl*4      
;   886724 / hl
;  duration: 1/1000s = 18.6012, DE=1000/ms * 18.6012
;-----------------------------------------------
piano:          ld      a,81h+1ch
                ld      c,PITCHL
                set     4,h
                out     (c),l
                inc     c
                out     (c),h
                inc     c
piano1:         out     (c),a
                ld      h,d
                ld      l,e
                ld      b,a
piano2:         dec     hl              ;4          ((26*de)+57)*7
                ld      a,h             ;4
                or      l               ;4
                jr      nz,piano2       ;12
                ld      a,b
                sub     4
                ld      b,a
                cp      81h
                jr      nc,piano1       ;*7
                ret

;-----------------------------------------------
LA12F:          db      043h    ;A12F: C
LA130:          db      000h    ;A130: .
LA131:          db      001h    ;A131: .
LA132:          db      0FFh,0A0h,0A8h
LA135:          db      0FFh
LA136:          ds      60

LA172:          db      000h    ;A172: .
LA173:          db      01Ah    ;A173: .
LA174:          db      000h    ;A174: .
LA175:          db      0A0h    ;A175: .
LA176:          db      088h    ;A176: .
LA177:          db      000h    ;A177: .
LA178:          db      001h    ;A178: .
LA179:          db      012h,0A0h,088h
LA17C:          dw      0                       ;movements (UD / LR)
LA17E:          db      012h,002h,000h,000h,000h

;+00
;+01    ROW in pixels
;+02    COL in pixels
;+03
;+04
;+05    ? 1Eh
;+06
;+07
;+08
;+09
;+0a
;+0b    ? 0
;+0c    ID
;+0d    ? 0
;+0e    ? 0
;+0f
;+10

LA183:          db      002h
LA184:          db      00Ch,058h,001h,000h,017h,00Ch,058h,001h,000h,017h,001h,004h,000h,000h,001h,000h,002h,074h
                db      070h,001h,000h,017h,074h,070h,001h,000h,017h,001h,003h,000h,000h,000h,003h,000h,0A0h,084h
                db      000h,001h,012h,0A0h,084h,000h,001h,012h,002h,002h,000h,000h,000h,000h,000h,0A0h,0B4h,000h
                db      0FFh,015h,0A0h,0B4h,000h,0FFh,015h,002h,001h,000h,000h,000h,000h,000h,028h,034h,000h,0FFh
                db      013h,028h,034h,000h,0FFh,013h,000h,001h,000h,001h,000h,000h
LA1D8:          db      000h    ;A1D8: .

L98D5:          dw      L98EE
                dw      L9A76
                dw      L9ADC
                dw      L9BD9

L98DD:          db      000h    ;98DD: .

;17 bytes table

L98DE:          db      0A0h            ;98DE: .
L98DF:          db      084h,000h       ;98DF: ..
L98E1:          db      001h            ;98E1: .
L98E2:          db      012h
L98E3:          db      0A0h,084h       ;98E2: ...
L98E5:          db      000h            ;98E5: .
L98E6:          db      001h            ;98E6: .
L98E7:          db      012h            ;98E7: .
L98E8:          db      002h            ;98E8: .
L98E9:          db      002h            ;98E9: .
L98EA:          db      000h            ;98EA: .
L98EB:          db      000h            ;98EB: .
L98EC:          db      000h,000h       ;98EC: ..


;-----------------------------------------------
;count_chests (9876)
;-----------------------------------------------

count_chests:   LD      BC,0300H
                LD      D,00H
                LD      HL,LAB32
count_chests1:  LD      A,(HL)
                CP      07H
                JR      NZ,count_chests2
                INC     D
count_chests2:  INC     HL
                DEC     BC
                LD      A,B
                OR      C
                JR      NZ,count_chests1
                LD      A,D
                LD      (chests),A
                LD      (L91B5),A
                RET

;-----------------------------------------------
;move_enemy (977B)
;-----------------------------------------------

L977B:          LD      (IY+0CH),B
                LD      A,B
                AND     A
                LD      A,0f0h                  ;white
                JR      Z,L9786
                LD      A,0ffh                  ;purple
L9786:          LD      C,(IX+00H)
                LD      B,(IX+01H)
                CALL    set_attr
                SLA     B
                SLA     B
                SLA     B
                SLA     C
                SLA     C
                SLA     C
                PUSH    BC
                LD      (IY+01H),C
                LD      (IY+02H),B
                LD      (IY+05H),1EH
                LD      (IY+0BH),00H
                LD      (IY+0DH),00H
                LD      (IY+0EH),00H
                LD      A,C                     ;next row
                ADD     A,08H
                LD      C,A
                CP      0B0H                    ;under bottom of screen area
                JR      NZ,L97BD
L97BA:          XOR     A
                JR      L97C9

L97BD:          CALL    get_room_element        ;get room element under enemy or self
                AND     A
                JR      Z,L97C7                 ;empty?
                CP      04H
                JR      C,L97BA
L97C7:          LD      A,01H
L97C9:          LD      (IY+00H),A
                POP     BC
                LD      A,(IY+0CH)
                AND     A
                RET     Z
                LD      D,01H
                LD      A,(LA176)
                CP      B
                JR      NZ,L97DE
                LD      D,00H
                JR      L97E2

L97DE:          JR      NC,L97E2
                LD      D,0FFH
L97E2:          LD      (IY+08H),00H
                LD      (IY+09H),D
                LD      (IY+0FH),00H
                LD      (IY+10H),00H
                RET

;-----------------------------------------------
;xor char
;  inputs: B: col, C: row, A: char
;
;15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
; 0  1  0 Y7 Y6 Y2 Y1 Y0 Y5 Y4 Y3 X4 X3 X2 X1 X0
;-----------------------------------------------

L983E:          SRL     B
                SRL     B
                SRL     B
                SRL     C
                SRL     C
                SRL     C
L984A:          PUSH    BC                      ;enemy get chest
                PUSH    DE
                PUSH    HL
                PUSH    AF

                LD      DE,SCREEN               ;calc screen address
                LD      H,C
                LD      L,0
                ADD     HL,HL
                ADD     HL,DE
                LD      C,B
                LD      B,0
                ADD     HL,BC
                ADD     HL,BC

;               LD      A,18H
;               AND     C
;               ADD     A,40H
;               LD      H,A

;               LD      A,C
;               ADD     A,A
;               ADD     A,A
;               ADD     A,A
;               ADD     A,A
;               ADD     A,A
;               ADD     A,B
;               LD      L,A

                POP     AF
                PUSH    HL
                LD      L,A
                LD      H,00H
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                LD      DE,chrgen
                ADD     HL,DE
                POP     DE

                ;DE screen address
                ;HL chrgen address

                push    ix
                ld      ix,bitconv

                LD      B,08H
L986B:          push    bc
L986B_1:        ld      a,(hl)
                rrca
                rrca
                rrca
                rrca
                and     0fh
                ld      (L986B_2+2),a

                ex      de,hl
                ld      a,(hl)
                rlca
                rlca
                rlca
                rlca
                or      (hl)
L986B_2:        xor     (ix+0)
                ld      (hl),a
                ex      de,hl
                inc     de

                ld      a,(hl)
                and     0fh
                ld      (L986B_3+2),a
                ex      de,hl
                ld      a,(hl)
                rlca
                rlca
                rlca
                rlca
                or      (hl)
L986B_3:        xor     (ix+0)
                ld      (hl),a
                ex      de,hl
                inc     hl
                LD      A,E
                ADD     A,63
                LD      E,A
                LD      A,D
                ADC     A,0
                LD      D,A
                pop     bc
                DJNZ    L986B

                pop     ix
                POP     HL
                POP     DE
                POP     BC
                RET

;-----------------------------------------------
;set room element
;-----------------------------------------------

L981D:          SRL     B
                SRL     B
                SRL     B
                LD      E,B
                LD      B,00H
                LD      D,A
                LD      A,C
                AND     0F8H
                ADD     A,A
                JR      NC,L982F
                LD      B,02H
L982F:          ADD     A,A
                JR      NC,L9833
                INC     B
L9833:          LD      C,A
                LD      A,D
                LD      HL,LAB32
                ADD     HL,BC
                LD      D,00H
                ADD     HL,DE
                LD      (HL),A
                RET

;set blank chars to white

L9CE8:          LD      C,00H
                LD      HL,LAB32
L9CED:          LD      B,00H
L9CEF:          LD      A,(HL)
                INC     HL
                AND     A
                JR      NZ,L9CF9
                LD      A,0f0h
                CALL    set_attr
L9CF9:          INC     B
                BIT     5,B
                JR      Z,L9CEF
                INC     C
                LD      A,22
                CP      C
                JR      NZ,L9CED
                RET
;-----------------------------------------------
;play
;-----------------------------------------------

play0:          CALL    L9CE8                   ;set blank char attr to white
                LD      A,brkanimend
                LD      (LA132),A
                LD      DE,LA136+1
                LD      HL,LA136
                LD      BC,60-1
                LD      (HL),A
                LDIR

                CALL    count_chests
                LD      IX,L919B                ;self positions
                LD      IY,LA174
                LD      B,00H
                CALL    L977B                   ;move self
                LD      IX,L919D                ;stars buffer
                LD      A,(L919A)               ;enemy count
                LD      B,A
                LD      IY,LA183
L9242:          PUSH    BC
                CALL    L977B                   ;move enemy
                LD      DE,0011H
                ADD     IY,DE
                LD      DE,0002H
                ADD     IX,DE
                POP     BC
                DJNZ    L9242

L9253:          ld      a,6                     ;check shift
                call    getkey
                bit     3,a
                jr      nz,L92A1

                ld      a,4
                call    getkey
                BIT     6,A
                JP      Z,L9CD3                 ;shift A - abort (die)

                ld      a,2
                call    getkey
                bit     7,a
                ret     nz
                LD      A,01H                   ;shift R - game over
                LD      (lives),A
                JP      L9CD3                   ;-> die

L92A1:          LD      HL,LA173
                INC     (HL)
                call    wait
                LD      BC,(LA175)
                CALL    L9804                   ;get left and right elements into D and E
                LD      A,D
                CP      01H                     ;wall? E.WALL
                JP      Z,L9CD3
                LD      A,E
                CP      01H
                JP      Z,L9CD3

                ;check enemy and self collision
;!!!
                LD      IX,LA184
                LD      DE,0011H
                LD      A,(L919A)               ;enemy count
L92C5:          PUSH    AF
                LD      L,(IX+00H)
                LD      H,(IX+01H)
                ADD     IX,DE
                LD      A,H
                SUB     B
                JR      NC,L92D4
                NEG
L92D4:          CP      06H
                JR      NC,L92E3
                LD      A,L
                SUB     C
                JR      NC,L92DE
                NEG
L92DE:          CP      06H
        if  invulnerable=0
                JP      C,L9CD2                 ;enemy and self collision? -> die
        endif

L92E3:          POP     AF
                DEC     A
                JR      NZ,L92C5

                ;no collision, continue game

                LD      A,(LA174)
                CP      01H
                JR      Z,L92FC

                CALL    test_lr                 ;read movements
                LD      B,D                     ;B left or right
                PUSH    BC
                CALL    test_ud
                POP     BC
                LD      C,D                     ;C up or down
;@@@
                LD      (LA17C),BC              ;save movements
L92FC:          LD      IX,LA174
                CALL    L98AD
                LD      BC,(L98DE)
                LD      A,C
                OR      B
                AND     07H
                JP      NZ,L93A3
                CALL    get_room_element        ;get room element

                CP      07H                     ;chest?
                JP      NZ,L93A3

                ;get chest

                PUSH    BC
                SRL     B
                SRL     B
                SRL     B
                SRL     C
                SRL     C
                SRL     C
                LD      A,0ffh                  ;purple
                CALL    set_attr

                LD      A,27H
                CALL    L984A                   ;xor char
                POP     BC
                XOR     A
                CALL    L981D                   ;set new room element

                LD      BC,50                   ;add 250 pts to score
                CALL    L9159
;               LD      DE,0007H
;               LD      HL,03E8H*3125/3547
;               CALL    BEEPER

                ld      hl,3651                 ;440Hz
                ld      de,310                 ;1/60sec
                call    piano

                LD      HL,chests
                DEC     (HL)
                JR      NZ,L93A3

                LD      HL,LAB32                ;room elements
                LD      C,00H
L934D:          LD      B,00H
L934F:          LD      A,(HL)
                CP      06H                     ;hidden ladder
                JR      NZ,L935B

                LD      (HL),03H
                LD      A,23H
                CALL    L984A                   ;xor char

L935B:          INC     HL
                INC     B
                BIT     5,B
                JR      Z,L934F
                INC     C
                LD      A,16H
                CP      C
                JR      NZ,L934D

;               LD      HL,086BH                ;hl=437500/f-30 (086Bh = 200Hz)
;               LD      DE,001DH                ;0.145s
;               CALL    BEEPER
;               LD      HL,067CH                ;259Hz
;               LD      DE,0024H                ;0.139s
;               CALL    BEEPER
;               LD      HL,04B8H                ;353Hz
;               LD      DE,0032H                ;0.141s
;               CALL    BEEPER
;               LD      HL,042BH                ;399Hz
;               LD      DE,0037H                ;0.138s
;               CALL    BEEPER
;               LD      B,05H
;L938D:         call    wait
;               DJNZ    L938D
;               LD      HL,04B8H                ;353Hz
;               LD      DE,0027H                ;0.11s
;               CALL    BEEPER
;               LD      HL,042BH                ;399Hz
;               LD      DE,006EH                ;0.28s
;               CALL    BEEPER

;  pitch: 4095 - (3125000 / 16 / freq)
;  duration: 1/1000s = 18.6012, DE=1000/ms * 18.6012

                ld      hl,3207
                ld      de,2604
                call    piano
                ld      hl,3346
                call    piano
                ld      hl,3535
                call    piano
                ld      hl,3597
                call    piano
                LD      B,05H
L938D:          call    wait
                DJNZ    L938D
                ld      hl,3346
                ld      de,2046
                call    piano
                ld      hl,3346
                ld      de,5208
                call    piano

L93A3:          LD      A,(chests)
                AND     A
                JR      NZ,L93B0
                LD      A,(L98DE)
                AND     A
                JP      Z,L9892         ;sound next level
;***
L93B0:          CALL    L9D05
                LD      A,(LA173)
                AND     03H
                CALL    Z,L9E1F         ;restore bricks
                CALL    test_fire
                LD      A,D
                AND     A
                JR      NZ,L93C6
                XOR     A
                LD      (LA172),A
L93C6:          call    wait
                CALL    read_kbd
                CP      48H                     ;H - Pause
                JR      NZ,L93E3
L93D5:          CALL    read_kbd
                CP      0FFH
                JR      NZ,L93D5
L93DC:          CALL    read_kbd
                CP      0FFH
                JR      Z,L93DC

L93E3:          LD      IX,LA183
                LD      A,(L919A)
L93EA:          PUSH    AF
                LD      HL,LA173
                XOR     (HL)
                AND     01H
                JP      Z,L95E6
                LD      A,(IX+00H)
                CP      05H
                JP      Z,L95F3
                LD      C,(IX+01H)
                LD      B,(IX+02H)
                LD      A,B
                OR      C
                AND     07H
                JR      NZ,L9436
                CALL    get_room_element
                CP      01H
                JP      Z,L96AD
                CP      02H
                JR      NZ,L9436
                PUSH    BC
                LD      A,(IX+10H)
                AND     A
                JR      Z,L9432
                CP      06H
                JR      C,L9435
                JR      NZ,L9432
                LD      A,(chests)
                AND     A
                LD      A,06H
                JR      NZ,L9432
                PUSH    BC
                LD      A,23H
                CALL    L983E
                POP     BC
                LD      A,03H
L9432:          CALL    L981D
L9435:          POP     BC
L9436:          LD      A,0f0h
                CALL    L9E92
                CALL    L98AD           ;move enemy

                LD      (LA1D8),A
                PUSH    AF
                LD      BC,(L98DE)
                PUSH    BC
                LD      A,B
                OR      C
                AND     07H
                JP      NZ,L953F
                PUSH    BC
                LD      A,C
                SUB     08H
                LD      C,A
                JR      C,L94D3
                LD      A,(L98E1)
                AND     A
                JR      NZ,L94D3
                LD      DE,0003H
                LD      IY,LA136
                LD      A,14H
L9464:          LD      L,(IY+01H)
                LD      H,(IY+02H)
                AND     A
                SBC     HL,BC
                JR      NZ,L94CE
                LD      (IX+00H),05H
                LD      A,(IX+0FH)
                AND     A
                JR      Z,L9497
                CALL    get_room_element
                CP      07H
                JR      NZ,L9486
                LD      HL,chests
                DEC     (HL)
                JR      L9497

L9486:          PUSH    BC
                LD      A,07H
                CALL    L981D
                POP     BC
                LD      A,27H
                CALL    L983E
                LD      A,0f0h                  ;no yellow, white
                CALL    set_attr
L9497:          LD      (IX+0FH),28H
                POP     BC
                CALL    get_room_element
                CP      01H
                JR      NZ,L94AB
                POP     BC
                LD      (IX+0FH),00H
                JP      L957C

L94AB:          LD      A,02H
                PUSH    BC
                CALL    L981D
                POP     BC
                SRL     C
                SRL     C
                SRL     C
                SRL     B
                SRL     B
                SRL     B
                LD      A,0ffh                  ;purple
                CALL    set_attr
                POP     BC
                POP     BC
                LD      BC,15                   ;add 75 pts to score
                CALL    L9159
                JP      L95E6

L94CE:          ADD     IY,DE
                DEC     A
                JR      NZ,L9464
L94D3:          POP     BC
                LD      A,(LA1D8)
                CP      0FFH
                JR      Z,L953F
                LD      A,(L98DD)
                AND     A
                JP      NZ,L953F
                SRL     B
                SRL     B
                SRL     B
                SRL     C
                SRL     C
                SRL     C
                LD      A,(L98EC)
                AND     A
                JR      NZ,L951B
                CALL    L8F37
                CP      07H
                JR      NZ,L953F
                CALL    rnd
                AND     01H
                JR      NZ,L953F
                LD      A,27H
                CALL    L984A
                LD      A,0f0h
                CALL    set_attr
                LD      A,01H
                LD      (IX+0FH),A
                DEC     A
                LD      BC,(L98DE)
                CALL    L981D
                JR      L953F

L951B:          CALL    L8F37
                AND     A
                JR      NZ,L953F
                CALL    rnd
                AND     07H
                JR      NZ,L953F
                LD      A,27H
                CALL    L984A
                LD      A,0f0h
                CALL    set_attr
                LD      A,07H
                LD      BC,(L98DE)
                CALL    L981D
                XOR     A
                LD      (IX+0FH),A
L953F:          POP     BC
                PUSH    BC
                LD      A,0ffh
                CALL    L9E92
                POP     BC
                LD      A,B
                OR      C
                AND     07H
                JR      NZ,L9563
                CALL    get_room_element
                CP      01H
                JR      Z,L957C
                LD      (IX+10H),A
                AND     A
                JR      Z,L955E
                CP      06H
                JR      NZ,L9563
L955E:          LD      A,02H
                CALL    L981D
L9563:          LD      BC,(L98DE)
                LD      A,B
                AND     07H
                JR      NZ,L9582
                LD      A,C
                AND     07H
                JR      Z,L9575
                LD      A,C
                ADD     A,08H
                LD      C,A
L9575:          CALL    get_room_element
                CP      01H
                JR      NZ,L9580
L957C:          POP     AF
                JP      L96AD

L9580:          JR      L958F

L9582:          CALL    L9804
                LD      A,D
                CP      01H
                JR      Z,L957C
                LD      A,E
                CP      01H
                JR      Z,L957C
L958F:          LD      HL,(LA175)
                LD      DE,0101H
                LD      BC,(L98DE)
                LD      A,H
                CP      B
                JR      NZ,L959E
                DEC     D
L959E:          JR      NC,L95A2
                LD      D,0FFH
L95A2:          LD      A,L
                CP      C
                JR      NZ,L95A7
                DEC     E
L95A7:          JR      NC,L95AB
                LD      E,0FFH
L95AB:          LD      (LA130),DE
                LD      BC,L95D3
                LD      HL,L9FFC
                LD      A,(L98DD)
                AND     A
                JR      Z,L95CC
                LD      HL,L9F81
                CP      01H
                JR      Z,L95CC
                LD      HL,LA08A
                CP      02H
                JR      Z,L95CC
                LD      HL,L9F8C
L95CC:          POP     AF
                PUSH    BC
                LD      BC,(L98DE)
                JP      (HL)

L95D3:          LD      HL,(L98E5)
                LD      DE,(L98EA)
                LD      (IX+08H),L
                LD      (IX+09H),H
                LD      (IX+0DH),E
                LD      (IX+0EH),D
L95E6:          POP     AF
                LD      DE,0011H
                ADD     IX,DE
                DEC     A
                JP      NZ,L93EA
                JP      L9253

L95F3:          DEC     (IX+0FH)
                LD      C,(IX+01H)
                LD      B,(IX+02H)
                LD      A,(IX+0FH)
                CP      04H
                JR      C,L9613
                CALL    get_room_element
                CP      01H
                JR      NZ,L95E6
                LD      (IX+0FH),00H
                JP      L96AD

L9611:          JR      L95E6

L9613:          LD      (IX+08H),0FFH
                LD      (IX+09H),00H
                LD      A,C
                AND     07H
                JR      Z,L9624
                LD      A,C
                ADD     A,08H
                LD      C,A
L9624:          CALL    get_room_element
                CP      01H
                JR      NZ,L9632
                LD      (IX+0FH),00H
                JP      L96AD

L9632:          LD      A,(IX+0FH)
                CP      03H
                JR      NZ,L963E
                LD      A,03H
                CALL    L981D
L963E:          LD      A,02H
                LD      (IX+00H),A
                CALL    L98AD
                CP      0FFH
                LD      A,05H
                LD      (IX+00H),A
                JR      NZ,L9655
                INC     (IX+0FH)
                JP      L95E6

L9655:          LD      BC,(L98DE)
                SRL     B
                SRL     B
                SRL     B
                SRL     C
                SRL     C
                SRL     C
                CALL    get_attr
                CP      0f0h
                JR      NZ,L9671
                LD      A,0ffh
                CALL    set_attr
L9671:          LD      A,(IX+0FH)
                AND     A
                JP      NZ,L95E6
                XOR     A
                LD      (IX+00H),A
                LD      BC,(L98DE)
                LD      A,C
                ADD     A,08H
                LD      C,A
                PUSH    BC
                LD      A,(LA176)
                CP      B
                LD      D,01H
                JR      NC,L968F
                LD      D,0FFH
L968F:          LD      (IX+09H),D
                LD      (IX+08H),00H
                CALL    L98AD
                POP     BC
                CALL    get_room_element
                CP      03H
                JP      NZ,L95E6
                XOR     A
                CALL    L981D
                JP      L95E6

L96A9:          LD      (IX+0FH),00H
L96AD:          
                LD      C,(IX+01H)
                LD      B,(IX+02H)
                LD      A,(IX+05H)
                CALL    L9712
                LD      BC,15
                CALL    L9159                   ;;add 75 pts to score
L96BF:          LD      E,00H
L96C1:          LD      D,0AH
L96C3:          CALL    rnd
                AND     1FH
                LD      B,A
                LD      C,E
                PUSH    DE
                CALL    L8F37
                POP     DE
                AND     A
                LD      L,00H
                JR      Z,L96EF
                CP      04H
                LD      L,03H
                JR      Z,L96EF
                CP      06H
                LD      L,00H
                JR      Z,L96EF
                CP      07H
                JR      Z,L96EF
                DEC     D
                JR      NZ,L96C3
                INC     E
                LD      A,04H
                CP      E
                JR      Z,L96BF
                JR      L96C1

L96EF:          LD      (IX+00H),L
                LD      A,B
                ADD     A,A
                ADD     A,A
                ADD     A,A
                LD      B,A
                LD      A,C
                ADD     A,A
                ADD     A,A
                ADD     A,A
                LD      C,A
                LD      (IX+01H),C
                LD      (IX+02H),B
                LD      (IX+05H),1EH
                LD      (IX+10H),02H
                LD      A,1EH
                CALL    L9712
                JP      L95E6

;draw char with xor
;*****
L9712:          ld      de,chrgen
                ADD     A,A
                ADD     A,A
                ADD     A,A
                add     a,e
                ld      e,a
                ld      a,d
                adc     a,0
                ld      d,a

                LD      A,B                     ;col offset in pixels
                AND     07H
                LD      (L974E),A
                LD      A,L975E_1-L975E         ;jr offset, if 0, must be clear right pixels
                JR      Z,L9723
                XOR     A
L9723:          LD      (L975D),A               ;set jr offset
                SRL     B
                SRL     B
                SRL     B

                push    de                      ;save char addr
                LD      DE,SCREEN               ;calc screen address
                LD      L,C
                LD      H,0
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,HL
                ADD     HL,DE
                LD      C,B
                LD      B,0
                ADD     HL,BC
                ADD     HL,BC
                pop     de                      ;restore char addr

                LD      B,08H
L9747:          PUSH    BC
                LD      A,(DE)                  ;get char
                LD      C,A
                INC     DE
                LD      B,00H
                LD      A,04H
L974E           equ     $-1

;CB pppp pppp 0000 0000 -> shift A

                AND     A
                JR      Z,L9759
L9752:          RR      C
                RR      B
                DEC     A
                JR      NZ,L9752

;C bal oldai, B jobb oldali karakterek
;DE-t nem bantjuk
;HL display cim

L9759:          ld      a,c
                call    xorch
                JR      L975E           ;+00 or +05
L975D           equ     $-1

L975E:          INC     HL
                inc     hl
                ld      a,b
fixxor2         call    xorch
                dec     hl
                dec     hl
L975E_1:        ld      a,l
                add     a,64
                ld      l,a
                ld      a,h
                adc     a,0
                ld      h,a

                POP     BC
                DJNZ    L9747
                RET

xorch:          push    ix
                ld      ix,bitconv

                push    af
                rrca                    ;zx char -> tvc char
                rrca
                rrca
                rrca
                and     0fh
                ld      (xorch1+2),a
                pop     af
                and     0fh
                ld      (xorch2+2),a

;                ld      a,0f0h
;                and     (hl)

;                ld      a,(hl)          ;set display byte to Palette 3
;                rlca
;                rlca
;                rlca
;                rlca
;                or      (hl)

                ld      a,(hl)
xorch1:         xor     (ix+0)          ;xor tvc char
andval1         and     0f0h
                ld      (hl),a          ;to display
                inc     hl

;                ld      a,0f0h
;                and     (hl)
;                ld      a,(hl)
;                rlca
;                rlca
;                rlca
;                rlca
;                or      (hl)

                ld      a,(hl)
xorch2:         xor     (ix+0)
andval2         and     0f0h
                ld      (hl),a
                dec     hl
                pop     ix
                ret

;get room element

L8F37:          PUSH    BC
                LD      HL,LAB32                ;room elements
                LD      E,B
                LD      D,00H
                ADD     HL,DE
                SLA     C
                SLA     C
                SLA     C
                SLA     C
                JR      NC,L8F4B
                INC     H
                INC     H
L8F4B:          SLA     C
                JR      NC,L8F50
                INC     H
L8F50:          LD      B,00H
                ADD     HL,BC
                LD      A,(HL)
                POP     BC
                RET

get_room_element:               PUSH    BC
                SRL     C
                SRL     C
                SRL     C
                SRL     B
                SRL     B
                SRL     B
                CALL    L8F37                   ;get room element
                POP     BC
                RET

L9804:          PUSH    BC                      ;save pixel positions
                CALL    get_room_element                        ;get room element
                LD      D,A                     ;D left element
                POP     BC
                LD      A,B
                AND     0F8H
                CP      B
                LD      E,00H
                RET     Z                       ;position on byte? if yes, ret

                PUSH    BC
                PUSH    DE
                ADD     A,08H
                LD      B,A
                CALL    get_room_element                        ;get right element
                POP     DE
                LD      E,A                     ;E right element
                POP     BC
                RET

;-----------------------------------------------

L98EE:          LD      A,(L98DF)
                LD      D,A
                AND     0F8H
                CP      D
                JP      NZ,L9988
                LD      A,(L98E5)
                CP      0FFH
                JR      NZ,L9929
                LD      BC,(L98DE)
                CALL    get_room_element
                CP      03H
                JR      NZ,L9959
                INC     C
                DEC     C
                JR      Z,L9959
                DEC     C
                DEC     C
                CALL    get_room_element
                CP      01H
                JR      Z,L9959
                CP      02H
                JR      Z,L9959
                CP      05H
                JR      Z,L9959
                LD      A,02H
                LD      HL,00FFH
                LD      D,16H
                JP      L9A63

L9929:          CP      01H
                JR      NZ,L9959
                LD      BC,(L98DE)
                LD      A,C
                ADD     A,08H
                CP      0B0H
                JR      Z,L9959
                LD      C,A
                CALL    get_room_element
                CP      07H
                JR      Z,L994B
                CP      06H
                JR      Z,L994B
                AND     A
                JR      Z,L994B
                CP      03H
                JR      NZ,L9959
L994B:          LD      A,C
                SUB     06H
                LD      C,A
                LD      A,02H
                LD      HL,0001H
                LD      D,16H
                JP      L9A63

L9959:          LD      BC,(L98DE)
                CALL    get_room_element
                CP      03H
                JR      Z,L9988
                LD      A,C
                ADD     A,08H
                CP      0B0H
                JR      Z,L9988
                LD      C,A
                CALL    get_room_element
                CP      01H
                JR      Z,L9988
                CP      02H
                JR      Z,L9988
                CP      03H
                JR      Z,L9988
L997B:          LD      D,1EH
                LD      HL,0001H
                LD      A,C
                SUB     06H
                LD      C,A
                LD      A,L
                JP      L9A63

L9988:          LD      A,(L98E6)
                AND     A
                JP      Z,L9A73
                ADD     A,A
                LD      BC,(L98DE)
                ADD     A,B
                CP      0FEH
                JP      Z,L9A73
                CP      0FAH
                JP      Z,L9A73
                LD      B,A
                LD      (L98E3),BC
                CALL    get_room_element
                CP      01H
                JP      Z,L9A73
                CP      02H
                JP      Z,L9A73
                LD      A,B
                AND     0F8H
                CP      B
                JR      Z,L99C9
                ADD     A,08H
                LD      B,A
                CALL    get_room_element
                CP      01H
                JP      Z,L9A73
                CP      02H
                JP      Z,L9A73
                JR      L9A09

L99C9:          LD      BC,(L98E3)
                CALL    get_room_element
                CP      04H
                JR      NZ,L99E0
                LD      A,03H
                LD      HL,(L98E5)
                LD      L,00H
                LD      D,1DH
                JP      L9A63

L99E0:          LD      A,C
                ADD     A,08H
                LD      C,A
                CP      0B0H
                JR      Z,L9A09
                CALL    get_room_element
                CP      01H
                JR      Z,L9A09
                CP      02H
                JR      Z,L9A09
                CP      03H
                JR      Z,L9A09
                LD      A,C
                SUB     08H
                LD      C,A
                CALL    get_room_element
                CP      03H
                JR      Z,L9A09
                LD      A,C
                ADD     A,08H
                LD      C,A
                JP      L997B

L9A09:          LD      A,(L98E8)
                INC     A
                CP      03H
                JR      NZ,L9A12
                XOR     A
L9A12:          LD      (L98E8),A
                LD      A,(L98E6)
                LD      D,10H
                CP      01H
                JR      Z,L9A20
                LD      D,13H
L9A20:          LD      A,(L98E8)
                ADD     A,D
                LD      (L98E7),A
                LD      (IX+08H),00H
L9A2B:          LD      BC,(L98DE)
                LD      A,(L98E9)
                AND     A
                JR      Z,L9A44
                PUSH    BC
                LD      DE,(L98E5)
                CALL    L9F11
                JR      Z,L9A43
                POP     BC
                LD      A,0FFH
                RET

L9A43:          POP     BC
L9A44:          LD      A,(L98E2)
                CALL    L9712
                LD      BC,0005H
                LD      DE,L98DE
                LD      HL,L98E3
                LDIR
                LD      BC,(L98DE)
                LD      A,(L98E2)
                CALL    L9712
                XOR     A
                JP      L98C8

L9A63:          LD      (L98DD),A
                LD      A,D
                LD      (L98E7),A
                LD      (L98E3),BC
                LD      (L98E5),HL
                JR      L9A2B

L9A73:          LD      A,0FFH
                RET

L9A76:          LD      HL,0001H
                LD      (L98E5),HL
                XOR     A
                LD      (L98E8),A

                LD      BC,(L98DE)
                INC     C
                INC     C
                LD      (L98E3),BC
                LD      A,C
                AND     0F8H
                CP      C
                JR      NZ,L9AD4
                ADD     A,08H
                LD      C,A
                CP      0B0H
                JR      Z,L9AC8
                CALL    L9804
                LD      A,D
                AND     A
                JR      Z,L9AA2
                CP      04H
                JR      C,L9AC8
L9AA2:          LD      A,E
                AND     A
                JR      Z,L9AAA
                CP      04H
                JR      C,L9AC8
L9AAA:          LD      BC,(L98E3)
                CALL    L9804
                LD      A,D
                CP      04H
                JR      Z,L9ABB
                LD      A,E
                CP      04H
                JR      NZ,L9AD4
L9ABB:          LD      A,18H
                LD      (L98E7),A
                LD      A,03H
                LD      (L98DD),A
                JP      L9A2B

L9AC8:          XOR     A
                LD      (L98DD),A
                LD      A,1EH
                LD      (L98E7),A
                JP      L9A2B

L9AD4:          LD      A,1EH
                LD      (L98E7),A
                JP      L9A2B

L9ADC:          LD      BC,(L98DE)
                LD      A,C
                AND     0F8H
                CP      C
                JR      NZ,L9B37
                LD      A,(L98E6)
                CP      0FFH
                JR      NZ,L9B0B
                LD      A,B
                AND     A
                JR      Z,L9B0B
                DEC     B
                DEC     B
                CALL    get_room_element
                CP      01H
                JR      Z,L9B0B
                CP      02H
                JR      Z,L9B0B
                CP      05H
                JR      Z,L9B0B
                LD      HL,0FF00H
                XOR     A
                LD      D,10H
                JP      L9A63

L9B0B:          LD      A,(L98E6)
                LD      BC,(L98DE)
                CP      01H
                JR      NZ,L9B37
                LD      A,B
                CP      0F8H
                JR      Z,L9B37
                INC     B
                INC     B
                CALL    L9804
                LD      A,E
                CP      01H
                JR      Z,L9B37
                CP      02H
                JR      Z,L9B37
                CP      05H
                JP      Z,L9B37
                LD      HL,0100H
                XOR     A
                LD      D,10H
                JP      L9A63

L9B37:          LD      A,(L98E5)
                AND     A
                JP      Z,L9A73
                ADD     A,A
                LD      BC,(L98DE)
                ADD     A,C
                LD      C,A
                CP      0FEH
                JP      Z,L9A73
                CALL    get_room_element
                CP      01H
                JP      Z,L9A73
                CP      02H
                JP      Z,L9A73
                CP      05H
                JP      Z,L9A73
                LD      (L98E3),BC
                LD      A,C
                AND     0F8H
                CP      C
                JR      NZ,L9BCA
                CALL    get_room_element
                CP      04H
                JR      NZ,L9B79
                LD      A,03H
                LD      D,1AH
                LD      HL,(L98E5)
                LD      H,00H
                JP      L9A63

L9B79:          LD      A,C
                ADD     A,08H
                LD      C,A
                CP      0B0H
                JR      Z,L9B8C
                CALL    get_room_element
                CP      01H
                JR      Z,L9B8C
                CP      02H
                JR      NZ,L9B98
L9B8C:          LD      A,10H
                LD      (L98E7),A
                XOR     A
                LD      (L98DD),A
                JP      L9A2B

L9B98:          LD      BC,(L98E3)
                CALL    get_room_element
                AND     A
                JR      Z,L9BA6
                CP      04H
                JR      C,L9BCA
L9BA6:          LD      A,C
                ADD     A,08H
                LD      C,A
                CALL    get_room_element
                CP      03H
                JR      Z,L9BBE
                LD      A,01H
                LD      (L98DD),A
                LD      A,1EH
                LD      (L98E7),A
                JP      L9A2B

L9BBE:          XOR     A
                LD      (L98DD),A
                LD      A,10H
                LD      (L98E7),A
                JP      L9A2B

L9BCA:          LD      HL,L98E8
                INC     (HL)
                RES     1,(HL)
                LD      A,(HL)
                ADD     A,16H
                LD      (L98E7),A
                JP      L9A2B

L9BD9:          LD      A,(L98E5)
                CP      01H
                JR      NZ,L9C1C
                LD      BC,(L98DE)
                LD      A,08H
                ADD     A,C
                LD      C,A
                CP      0B0H
                JR      Z,L9C1C
                LD      A,B
                AND     0F8H
                CP      B
                JR      NZ,L9C07
                CALL    get_room_element
                CP      03H
                JR      NZ,L9C07
                LD      A,C
                SUB     06H
                LD      C,A
                LD      HL,0001H
                LD      A,02H
                LD      D,16H
                JP      L9A63

L9C07:          CALL    L9804
                LD      A,D
                AND     A
                JR      Z,L9C12
                CP      04H
                JR      C,L9C1C
L9C12:          LD      A,E
                AND     A
                JP      Z,L997B
                CP      04H
                JP      NC,L997B
L9C1C:          LD      A,(L98E6)
                AND     A
                JP      Z,L9A73
                ADD     A,A
                LD      BC,(L98DE)
                ADD     A,B
                LD      B,A
                CP      0FEH
                JP      Z,L9A73
                CP      0FAH
                JP      Z,L9A73
                CALL    L9804
                LD      A,D
                CP      01H
                JP      Z,L9A73
                CP      02H
                JP      Z,L9A73
                CP      05H
                JP      Z,L9A73
                LD      A,E
                CP      01H
                JP      Z,L9A73
                CP      02H
                JP      Z,L9A73
                CP      05H
                JP      Z,L9A73
                LD      A,B
                AND     07H
                JR      NZ,L9CAE
                CALL    get_room_element
                CP      04H
                JR      Z,L9CAE
                CP      03H
                JR      NZ,L9C78
                LD      A,16H
                LD      (L98E7),A
                LD      A,02H
                LD      (L98DD),A
                LD      (L98E3),BC
                JP      L9A2B

L9C78:          LD      A,08H
                ADD     A,C
                LD      C,A
                CP      0B0H
                JR      Z,L9C9F
                CALL    get_room_element
                CP      01H
                JR      Z,L9C9F
                CP      02H
                JR      Z,L9C9F
                CP      03H
                JR      Z,L9C9F
                LD      A,C
                SUB     06H
                LD      C,A
                LD      A,01H
                LD      HL,(L98E5)
                LD      L,01H
                LD      D,16H
                JP      L9A63

L9C9F:          LD      A,C
                SUB     08H
                LD      C,A
                XOR     A
                LD      D,12H
                LD      HL,(L98E5)
                LD      L,00H
                JP      L9A63

L9CAE:          LD      A,(L98E8)
                INC     A
                CP      03H
                JR      NZ,L9CB7
                XOR     A
L9CB7:          LD      (L98E8),A
                LD      D,18H
                LD      L,A
                LD      A,(L98E6)
                CP      01H
                JR      Z,L9CC6
                LD      D,1BH
L9CC6:          LD      A,D
                ADD     A,L
                LD      (L98E7),A
                LD      (L98E3),BC
                JP      L9A2B
    if  allmaps = 1
vidpgin         ld      a,50h
                out     (PAGES),a
                ret

memp2in         ld      a,70h
                out     (PAGES),a
                ret
    endif
    
TVCsound        push    bc
                srl     h
                rr      l
                ld      a,h
                cp      10h
                jr      c,frqok
                ld      h,0fh
frqok           ex      de,hl
                ld      hl,1fffh
                or      a
                sbc     hl,de
                ld      a,81h+1ch
                ld      c,PITCHL
                out     (c),l
                inc     c
                out     (c),h
                inc     c
                out     (c),a
                pop     bc
                jp      delaybc

TVCvol0         ld      a,81h
                out     (VOLUME),a
                ret

L9CD2:          POP     AF
L9CD3:          LD      B,32H
L9CD5:          PUSH    BC
                LD      A,32H
                SUB     B
                LD      H,A             ;0000h-3100h
                LD      L,00H
;                LD      DE,0003H
;                CALL    BEEPER          ;act
                ld      bc,1670
                call    TVCsound
                POP     BC
                DJNZ    L9CD5
                call    TVCvol0
                XOR     A
                RET

L9892:          LD      B,1EH           ;sound next level
L9894:          PUSH    BC
                LD      A,B
                SRL     A
                LD      H,A             ;0f80h-0080h
                LD      L,80H
;                LD      DE,0003H
;                CALL    BEEPER          ;act
                ld      bc,1474
                call    TVCsound
                LD      BC,000AH
                CALL    L9159
                POP     BC
                DJNZ    L9894
                call    TVCvol0
                LD      A,01H
                RET

L98AD:          LD      A,(IX+00H)
                PUSH    IX
                POP     HL
                LD      DE,L98DD
                LD      BC,0011H
                LDIR
                ADD     A,A
                LD      E,A
                LD      D,00H
                LD      HL,L98D5
                ADD     HL,DE
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                EX      DE,HL
                JP      (HL)

L98C8:          PUSH    IX
                POP     DE
                LD      HL,L98DD
                LD      BC,000FH
                LDIR
                XOR     A
                RET

L9D05:          LD      A,(LA132)
                or      a
                jp      m,L9D84
;                CP      brkanimend
;                JR      Z,L9D84
                PUSH    AF
                LD      BC,(LA132+1)
                AND     A
                JR      NZ,L9D1F
                LD      A,08H
                ADD     A,C
                LD      C,A
                LD      A,21H
                CALL    L983E
                JR      L9D32

L9D1F:          DEC     A
                ADD     A,A
                ADD     A,0F0H
                PUSH    AF
                CALL    L983E
                POP     AF
                INC     C
                INC     A
                CALL    L984A
                LD      A,0f0h
                CALL    set_attr
L9D32:          LD      BC,(LA132+1)
                LD      A,08H
                ADD     A,C
                LD      C,A
                XOR     A
                CALL    L981D
                POP     AF
                CP      04H
                JR      NZ,L9D62
                LD      HL,LA136
                LD      B,14H
L9D48:          LD      A,(HL)
                CP      brkanimend
                JR      Z,L9D52
                INC     HL
                INC     HL
                INC     HL
                DJNZ    L9D48
L9D52:          LD      (HL),28H
                INC     HL
                LD      BC,(LA132+1)
                LD      (HL),C
                INC     HL
                LD      (HL),B
;                LD      A,0FFH
                ld      a,brkanimend
                LD      (LA132),A
                RET

L9D62:          ADD     A,A
                ADD     A,0F0H
                LD      BC,(LA132+1)
                PUSH    AF
                CALL    L983E
                POP     AF
                INC     A
                INC     C
                CALL    L984A
                LD      HL,LA132
                INC     (HL)
;                LD      DE,0002H
                LD      A,(HL)
                ADD     A,A
                ADD     A,04H
                LD      H,A
                ld      bc,592
                call    TVCsound
                call    TVCvol0
;                CALL    BEEPER          ;act
;                DI
                RET

L9D84:          CALL    test_fire
                LD      A,(LA174)
                CP      01H
                RET     Z
                LD      A,D
                AND     A
                JR      NZ,L9D95
                LD      (LA172),A
                RET

L9D95:          LD      A,(LA172)
                AND     A
                RET     NZ
                INC     A
                LD      (LA172),A
                LD      HL,LA135
                LD      A,(LA178)
                AND     A
                JR      Z,L9DA8
                LD      (HL),A
L9DA8:          LD      A,(HL)
                LD      BC,(LA175)
                LD      A,C
                AND     07H
                RET     NZ
                LD      A,(HL)
                CP      01H
                JR      Z,L9DC8
                LD      A,B
                AND     07H
                CP      B
                CP      04H
                CP      02H
                JR      NZ,L9DC2
                DEC     B
                DEC     B
L9DC2:          AND     A
                JR      NZ,L9DC6
                DEC     B
L9DC6:          JR      L9DD9

L9DC8:          LD      A,B
                CP      0F4H
                RET     NC
                AND     07H
                LD      D,08H
                CP      06H
                JR      NZ,L9DD6
                LD      D,0AH
L9DD6:          LD      A,B
                ADD     A,D
                LD      B,A
L9DD9:          LD      A,B
                AND     0F8H
                LD      B,A
                LD      (LA132+1),BC
                CALL    get_room_element
                CP      06H
                JR      Z,L9DEA
                AND     A
                RET     NZ
L9DEA:          LD      A,08H
                ADD     A,C
                LD      C,A
                CALL    get_room_element
                CP      01H
                RET     NZ
                XOR     A
                LD      (LA132),A
                LD      BC,(LA175)
                LD      A,B
                AND     07H
                RET     Z
                LD      A,(LA179)
                CALL    L9712
                LD      BC,(LA132+1)
                LD      A,(LA178)
                NEG
                ADD     A,A
                ADD     A,A
                ADD     A,A
                ADD     A,B
                LD      B,A
                LD      (LA175),BC
                LD      A,(LA179)
                CALL    L9712
                RET

fixbrick        push    af
                push    bc
                LD      DE,SCREEN
                LD      H,C
                LD      L,0
                ADD     HL,HL
                ADD     HL,DE
                LD      C,B
                LD      B,0
                ADD     HL,BC
                ADD     HL,BC

                LD      DE,63
                xor     a
                ld      bc,0f0bh
                ld      (hl),b
                inc     l
                ld      (hl),c
                add     hl,de
                ld      (hl),b
                inc     l
                ld      (hl),c
                add     hl,de
                ld      (hl),b
                inc     l
                ld      (hl),c
                add     hl,de
                ld      (hl),a
                inc     l
                ld      (hl),a
                add     hl,de
                ld      bc,0d0fh
                ld      (hl),b
                inc     l
                ld      (hl),c
                add     hl,de
                ld      (hl),b
                inc     l
                ld      (hl),c
                add     hl,de
                ld      (hl),b
                inc     l
                ld      (hl),c
                add     hl,de
                ld      (hl),a
                inc     l
                ld      (hl),a
                pop     bc
                pop     af
                ret

L9E1F:          LD      B,14H
                LD      HL,LA136
L9E24:          PUSH    BC
                PUSH    HL
                LD      A,(HL)
                CP      brkanimend
                JR      Z,L9E8A         ;end check (originally 0ffh)
                DEC     A
                LD      (HL),A
                INC     HL
                LD      C,(HL)
                INC     HL
                LD      B,(HL)
                jp      p,L9E53
                LD      A,C
                ADD     A,08H
                LD      C,A
                PUSH    BC
                LD      A,01H
                CALL    L981D
                POP     BC
                SRL     B
                SRL     B
                SRL     B
                SRL     C
                SRL     C
                SRL     C
;                LD      A,0fh           ;red
                call    fixbrick
;                CALL    set_attr
                JR      L9E8A

L9E53:          CP      04H
                JR      NC,L9E8A
                XOR     03H
                ADD     A,0F8H
                PUSH    AF
                LD      A,C
                ADD     A,08H
                LD      C,A
                CALL    get_room_element
                CP      07H
                JR      NZ,L9E6D
                POP     AF
                POP     HL
                PUSH    HL
                INC     (HL)
                JR      L9E8A

L9E6D:          POP     AF
                PUSH    AF
                CP      0F8H
                JR      NZ,L9E82
                SRL     B
                SRL     B
                SRL     B
                SRL     C
                SRL     C
                SRL     C
                POP     AF
                JR      L9E87

L9E82:          CALL    L983E
                POP     AF
                DEC     A
L9E87:          CALL    L984A
L9E8A:          POP     HL
                INC     HL
                INC     HL
                INC     HL
                POP     BC
                DJNZ    L9E24
                RET

L9E92:          LD      HL,0000H
                LD      (LA12F),A
                LD      A,C
                AND     07H
                JR      Z,L9E9E
                INC     L
L9E9E:          LD      A,B
                AND     07H
                JR      Z,L9EA4
                INC     H
L9EA4:          SRL     C
                SRL     B
                SRL     C
                SRL     B
                SRL     C
                SRL     B
                CALL    L9EC5
                LD      A,L
                AND     A
                JR      Z,L9EBD
                INC     C
                CALL    L9EC5
                DEC     C
                RET

L9EBD:          ;ld      a,c
                ;or      a
                ;jr      z,L9EBD_2
                ;dec     c
                ;call    L9EC5
                ;inc     c

L9EBD_2:        LD      A,H
                AND     A
                RET     Z
;                jr      z,L9EBD_1
                INC     B
                CALL    L9EC5
                RET

;L9EBD_1:        ld      a,b
;                or      a
;                ret     z
;                DEC     B
;                CALL    L9EC5
;                INC     B
;                RET

L9EC5:          PUSH    BC
                PUSH    HL
                CALL    L8F37
                POP     HL
                POP     BC
                CP      01H
                RET     Z
                CP      02H
                RET     Z
                CP      05H
                RET     Z
                CP      07H
                RET     Z
                LD      A,(LA12F)
                CALL    set_attr
                RET

L9EDF:          PUSH    BC
                PUSH    DE
                SRL     B
                SRL     B
                SRL     B
                SRL     C
                SRL     C
                SRL     C
                LD      A,D
                CP      0FFH
                JP      Z,L9F72
                CP      01H
                JP      Z,L9F7A
                LD      A,E
                CP      0FFH
                JP      Z,L9F54
                INC     C
                LD      A,16H
                CP      C
                JR      Z,L9F4F
                CALL    L8F37
                CP      01H
                JR      Z,L9F4F
                CP      02H
                JR      Z,L9F4F
L9F0F:          POP     DE
                POP     BC
L9F11:          LD      A,D
                PUSH    BC
                PUSH    DE
                ADD     A,A
                ADD     A,A
                ADD     A,B
                LD      B,A
                LD      A,E
                ADD     A,A
                ADD     A,A
                ADD     A,C
                LD      C,A
                LD      A,(L919A)
                LD      IY,LA183
                LD      DE,0011H
L9F27:          PUSH    AF
                CP      (IX+0CH)
                JR      Z,L9F45
                LD      A,(IY+02H)
                SUB     B
                JR      NC,L9F35
                NEG
L9F35:          CP      05H
                JR      NC,L9F45
                LD      A,(IY+01H)
                SUB     C
                JR      NC,L9F41
                NEG
L9F41:          CP      05H
                JR      C,L9F4E
L9F45:          ADD     IY,DE
                POP     AF
                DEC     A
                JR      NZ,L9F27
                POP     DE
                POP     BC
                RET

L9F4E:          POP     AF
L9F4F:          XOR     A
                INC     A
                POP     DE
                POP     BC
                RET

L9F54:          LD      A,(IX+10H)
                CP      03H
                JR      NZ,L9F4F
                DEC     C
                LD      A,C
                CP      0FFH
                JR      Z,L9F4F
L9F61:          CALL    L8F37
                CP      01H
                JR      Z,L9F4F
                CP      02H
                JR      Z,L9F4F
                CP      05H
                JR      Z,L9F4F
                JR      L9F0F

L9F72:          DEC     B
                LD      A,B
                CP      0FFH
                JR      Z,L9F4F
                JR      L9F61

L9F7A:          INC     B
                BIT     5,B
                JR      NZ,L9F4F
                JR      L9F61

L9F81:          LD      HL,0001H
                LD      (L98E5),HL
                DEC     L
                LD      (L98EA),HL
                RET

L9F8C:          CP      0FFH
                JR      Z,L9FD3
                LD      A,B
                AND     07H
                JR      NZ,L9FB1
                LD      D,01H
                LD      A,(LA130)
                CP      01H
                JR      NZ,L9FB1
                LD      DE,0001H
                CALL    L9EDF
                JR      NZ,L9FB1
                LD      (L98E5),DE
                LD      HL,0000H
                LD      (L98EA),HL
                RET

L9FB1:          LD      A,(LA131)
                LD      D,A
                LD      A,(L98E1)
                AND     A
                JR      NZ,L9FBC
                LD      A,D
L9FBC:          CP      D
                LD      A,00H
                JR      Z,L9FC2
                INC     A
L9FC2:          LD      (L98EB),A
L9FC5:          AND     A
                LD      A,D
                JR      Z,L9FCB
                NEG
L9FCB:          LD      (L98E6),A
                XOR     A
                LD      (L98E5),A
                RET

L9FD3:          LD      A,B
                AND     07H
                JR      NZ,L9FF1
                LD      A,(L98EB)
                AND     A
                JR      Z,L9FF1
                LD      DE,0001H
                CALL    L9EDF
                JR      NZ,L9FF1
                LD      (L98E5),DE
                LD      HL,0000H
                LD      (L98EA),HL
                RET

L9FF1:          LD      A,(L98EB)
                XOR     01H
                LD      HL,LA131
                LD      D,(HL)
                JR      L9FC5

L9FFC:          AND     A
                JR      NZ,LA059
                LD      A,B
                AND     07H
                JR      NZ,LA023
                LD      A,(L98EA)
                AND     A
                JR      NZ,LA023
                LD      A,(LA130)
                AND     A
                JR      Z,LA023
                LD      E,A
                LD      D,00H
                CALL    L9EDF
                JR      NZ,LA023
                LD      (L98E5),DE
                LD      HL,0000H
                LD      (L98EA),HL
                RET

LA023:          LD      HL,L98E6
                LD      A,(HL)
                AND     A
                LD      A,(LA131)
                JR      NZ,LA02E
                LD      (HL),A
LA02E:          LD      D,00H
                CP      (HL)
                JR      Z,LA034
                INC     D
LA034:          LD      A,D
                LD      (L98EB),A
LA038:          LD      A,(LA131)
                LD      HL,L98EB
                BIT     0,(HL)
                JR      Z,LA044
                NEG
LA044:          AND     A
                JR      NZ,LA04E
                LD      A,(LA178)
                AND     A
                JR      NZ,LA04E
                INC     A
LA04E:          LD      (L98E6),A
                XOR     A
                LD      (L98E5),A
                LD      (L98EA),A
                RET

LA059:          LD      A,B
                AND     07H
                JR      NZ,LA081
                LD      A,(LA130)
                AND     A
                JR      NZ,LA065
                INC     A
LA065:          LD      E,A
                LD      D,00H
                CALL    L9EDF
                JR      NZ,LA078
LA06D:          LD      (L98E5),DE
                LD      HL,0000H
                LD      (L98EA),HL
                RET

LA078:          LD      A,E
                NEG
                LD      E,A
                CALL    L9EDF
                JR      Z,LA06D
LA081:          LD      HL,L98EB
                LD      A,(HL)
                XOR     01H
                LD      (HL),A
                JR      LA038

LA08A:          AND     A
                JR      NZ,LA0F7
                PUSH    BC
                LD      A,C
                AND     0F8H
                CP      C
                JR      NZ,LA0C7
                ADD     A,08H
                LD      C,A
                CP      0B0H
                JR      Z,LA0B0
                LD      A,(LA131)
                AND     A
                JR      Z,LA0C7
                ADD     A,A
                ADD     A,A
                ADD     A,A
                ADD     A,B
                LD      B,A
                CALL    get_room_element
                AND     A
                JR      Z,LA0C7
                CP      05H
                JR      NC,LA0C7
LA0B0:          POP     BC
                LD      A,(LA131)
                LD      D,A
                LD      E,00H
                CALL    L9EDF
                JR      NZ,LA0C8
                LD      (L98E5),DE
                LD      HL,0000H
                LD      (L98EA),HL
                RET

LA0C7:          POP     BC
LA0C8:          LD      HL,L98E5
                LD      A,(HL)
                AND     A
                LD      A,(LA130)
                JR      NZ,LA0D3
                LD      (HL),A
LA0D3:          LD      D,00H
                CP      (HL)
                JR      Z,LA0D9
                INC     D
LA0D9:          LD      A,D
                LD      (L98EA),A
LA0DD:          AND     A
                LD      A,(LA130)
                JR      Z,LA0E5
                NEG
LA0E5:          AND     A
                JR      NZ,LA0EF
                LD      A,(LA177)
                AND     A
                JR      NZ,LA0EF
                DEC     A
LA0EF:          LD      (L98E5),A
                XOR     A
                LD      (L98E6),A
                RET

LA0F7:          LD      A,C
                AND     07H
                JR      NZ,LA126
                LD      A,(LA131)
                LD      D,A
                LD      E,00H
                CALL    L9EDF
                JR      NZ,LA112
                LD      (L98E5),DE
                LD      HL,0001H
                LD      (L98EA),HL
                RET

LA112:          LD      A,D
                NEG
                LD      D,A
                CALL    L9EDF
                JR      NZ,LA126
                LD      (L98E5),DE
                LD      HL,0100H
                LD      (L98EA),HL
                RET

LA126:          LD      HL,L98EA
                LD      A,(HL)
                XOR     01H
                LD      (HL),A
                JR      LA0DD

                include chrgen.asm
LAB32:          ds      22*32                   ;room elements
tmp_room:       ds      264
tmp_room_end:
attr:           ds      32*24

    if  allmaps = 0
                include room5.asm
    else
                include rooms.asm
    endif

                end

